--图鉴
Lua_HeroAtlasPanel = class("Lua_HeroAtlasPanel", Lua_DisplayObject);
function Lua_HeroAtlasPanel:ctor(p)
    self:superCall("ctor", p);
end

function Lua_HeroAtlasPanel:buildShowItem()
    self:superCall("buildShowItem");
    self:addLuaEvent("UPDATE_STAR_ATLAS_INFO", self, self.updateAtlasSiftInfo);
    self:addLuaEvent("SHOW_SELECT_HERO_WIND", self, self.showSelectHeroWind);

    self.dragContainer = Lua_DragContainer.new(self.content, 663, 930 + self.adaptHeight, Lua_AxisDefine.Vertical);
    self.dragContainer:setLocation(0, 77, 0);
    self.dragContainer:setCellSpacing(0, 10);

    local siftAllInfo = DataCenter.heroUtil.siftAllInfo;
    self.siftPosXs = Array();
    self.siftArr = Array();
    self.siftSpace = 82;
    local len = siftAllInfo:getSize();
    local item;
    local w = -(self.siftSpace * len) / 2 + self.siftSpace / 2;
    local posX;
    for i = 1, len do
        item = Lua_CampSiftBaseItem.new(self.content, self.siftSpace);
        item:setRectAnchor(7);
        
        posX = ((i - 1) % len) * self.siftSpace + w;
        item:setLocation(posX, 290, 0);

        item:setData(siftAllInfo[i]);
        item:setClickCallBack(self, self.updateAtlasSiftInfo);

        self.siftPosXs:add(posX);
        self.siftArr:add(item);
    end

    Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroAtlas();
end

function Lua_HeroAtlasPanel:dispose()
    if self.dragContainer ~= nil then
        TweenUtil.getInstance():stop(self.dragContainer.content);
        self.dragContainer:dispose();
        self.dragContainer = nil;
    end
    if self.siftArr ~= nil then
        self.siftArr:dispose();
        self.siftArr:clear();
        self.siftArr = nil;
    end
    if self.siftPosXs ~= nil then
        self.siftPosXs:clear();
        self.siftPosXs = nil;
    end
    self:superCall("dispose");
end

function Lua_HeroAtlasPanel:onScreenResize(adaptHeight)
    self.dragContainer:setContentRect(663, 930 + adaptHeight);
end

function Lua_HeroAtlasPanel:showSelectHeroWind(heroVo)
    DataCenter.heroAtlasData:onOpenAtlasWindow(heroVo.id, true, self.selectType);
end

function Lua_HeroAtlasPanel:updateShow()
    self.selectType = nil;
    self:updateAtlasSiftInfo(Lua_HeroUtil.All_TYPE);
end

function Lua_HeroAtlasPanel:updateAtlasSiftInfo(selectType) -- 更新筛选状态
    selectType = selectType == nil and Lua_HeroUtil.All_TYPE or selectType;
    if self.selectType == selectType then
        return;
    end
    self.selectType = selectType;
    
    local posX;
    local item;
    for i = 1, self.siftArr:getSize() do
        posX = self.siftPosXs[i];
        item = self.siftArr[i];
        if item.data.type > selectType then -- 往右移
            item:setLocation(posX + self.siftSpace / 2, item.y, 0);
        else -- 往左移
            item:setLocation(posX - self.siftSpace / 2, item.y, 0);
        end

        if item.data.type == selectType then
            item:setSelectEnable(true);
        else
            item:setSelectEnable(false);
        end
    end
    
    self:onInitDragList();
end

function Lua_HeroAtlasPanel:onInitDragList()
    TweenUtil.getInstance():stop(self.dragContainer.content);
    self.dragContainer:clearList();
    local idx;
    local showList;
    local index;
    local num;
    for i = 1, 6 do
        idx = 7 - i;
        data = DataCenter.heroAtlasData:getHeroAtlasArr(idx, self.selectType);
        if data ~= nil and data:getSize() > 0 then
            -- 标题
            self.dragContainer:addSubContainer(Lua_HeroAtlasItem, idx, false);
            -- 内容
            showList = {};
            index = 1;
            num = 0;
            for j = 1, data:getSize() do
                if showList[index] == nil then
                    showList[index] = Array();
                end
                showList[index]:add(data[j]);
                num = num + 1;
                if num == 3 then
                    index = index + 1;
                    num = 0;
                end
            end
            for j = 1, #showList do
                self.dragContainer:addSubContainer(Lua_HeroAtlasItem, showList[j], false);
            end
        end
    end
    self.dragContainer:updateChildPos();
    self.dragContainer:moveToIndex(1, true);
    self.dragContainer.canDrag = not self.dragContainer.bDragEnd;
    TweenUtil.getInstance():addTweenTargetAlpha(self.dragContainer.content, 0.5, 0, -1, true);
end




















Lua_HeroAtlasItem = class("Lua_HeroAtlasItem", Lua_DragContainerItem);
function Lua_HeroAtlasItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_HeroAtlasItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_HeroAtlasItem:dispose()
    if self.itemArr ~= nil then
        self.itemArr:dispose();
        self.itemArr:clear();
        self.itemArr = nil;
    end
    self.data = nil;
    self:superCall("dispose");
end

function Lua_HeroAtlasItem:setData(data)
    self.data = data;
    if type(data) == "number" then -- 标题
        if self.title_bg == nil then
            self.title_bg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_widget_008", 0, 0, 327, 46);
        end
        self.title_bg:setEnable(true);
        if self.title_name == nil then
            self.title_name = UICreate.createLabel(self.content, nil, 0, 0, 100, 31, 24);
            self.title_name.fontName = Lua_MyUISettings.huakangFontName;
            self.title_name.pivot = Lua_WindowUtil.getPivot(4);
            self.title_name.alignmentValue = 4;
            self.title_name.horizontalOverflowValue = 1;
            self.title_name.colorStr = Lua_ColorDefine.transColor("FFFEF0");
        end
        self.title_name:setEnable(true);
        self.title_name:setLangValue(126003 + data);

        if self.itemArr ~= nil then
            for i = 1, self.itemArr:getSize() do
                self.itemArr[i]:setEnable(false);
            end
        end
    else
        if self.title_bg ~= nil then
            self.title_bg:setEnable(false);
        end
        if self.title_name ~= nil then
            self.title_name:setEnable(false);
        end

        if self.itemArr == nil then
            self.itemArr = Array();
        end
        local len = self.itemArr:getSize();
        local dataLen = data:getSize();
        local maxLen = dataLen > len and dataLen or len;
        local item;
        local posX;
        for i = 1, maxLen do
            item = self.itemArr[i];
            if i > dataLen then
                if item ~= nil then
                    item:setEnable(false);
                end
            else
                if item == nil then
                    item = Lua_HeroAtlasCell.new(self.content);
                    self.itemArr:add(item);
                else
                    item:setEnable(true);
                end
                item:setRectSize(199, 338);
                posX = -221 + ((i - 1) % 3) * 221;
                item:setLocation(posX, 0, 0);
                item:setData(data[i]);
            end
        end
    end
end

function Lua_HeroAtlasItem:getWidth()
    return 663;
end

function Lua_HeroAtlasItem:getHeight()
    if type(self.data) == "number" then
        return 46;
    end
    return 338;
end

function Lua_HeroAtlasItem:onPressClick()
    if self.data == nil or type(self.data) == "number" then
        return;
    end

    local winPos = LuaUtil.getTouchPosInverseObj(self.mainContent);
    for i = 1, self.itemArr:getSize() do
        if self.itemArr[i].isActive and self.itemArr[i]:checkInBound(winPos.x, winPos.y) then
            self.itemArr[i]:onPressClick();
        end
    end
end

















-- 英雄显示Item
Lua_HeroAtlasCell = class("Lua_HeroAtlasCell", Lua_DisplayObject);
function Lua_HeroAtlasCell:ctor(p)
    self:superCall("ctor", p, "HeroAtlasCells_skin");
end

function Lua_HeroAtlasCell:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_HeroAtlasCell:dispose()
    if self.toolImg ~= nil then
        self.toolImg:dispose();
        self.toolImg = nil;
    end
    if self.starArr ~= nil then
        self.starArr:dispose();
        self.starArr:clear();
        self.starArr = nil;
    end
    self.data = nil;
    self:superCall("dispose");
end

function Lua_HeroAtlasCell:updateBound()
    local posX = self.posX == nil and 0 or self.posX;
    local posY = self.posY == nil and 0 or self.posY;
    local scaleX = self.scaleX == nil and 1 or self.scaleX;
    local scaleY = self.scaleY == nil and 1 or self.scaleY;
    self.minX = posX - self.w / 2 * scaleX;
    self.maxX = posX + self.w / 2 * scaleX;
    self.minY = posY - self.h / 2 * scaleY;
    self.maxY = posY + self.h / 2 * scaleY;
end

function Lua_HeroAtlasCell:setData(id)
    local data = DataCenter.heroAtlasData:getAtlasVoById(id);
    self.data = data.heroVo;
    self.name.text = self.data.name;
    self.icon_img:setUrl(data.path);
    self.mask:setEnable(not (data.isActivate));
    self.camp_icon:setAltas("common_altas_2", "ui_common_button_0"..25 + self.data.campType.."_n");
    self:showStar(self.data.initial_star);
    self.weaponName.text = data.heroVo.weaponName;
    self.avatarIcon:setAltas(data.heroVo.avatar_atlas_1, data.heroVo.avatar_sprite_1);
end

--显示星
function Lua_HeroAtlasCell:showStar(star)
    if star ~= nil and star > 0 then
        if self.starArr == nil then
            self.starArr = Array();
        end  
        local len = self.starArr:getSize();
        local starWidth = 23;
        local num = len;
        if len < star then
            num = star;
        end
        for i = 1, num do
            local item = self.starArr[i];
            if item == nil then
                item = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_label_05", 0, 0, 37, 38);
                item.siblingIndex = 1;
                self.starArr:add(item);
            else
                item:setEnable(i <= star);
            end
            item:setLocation(-77, 130 - (i - 1) * starWidth, 0);
        end
    else
        if self.starArr ~= nil then
            for i = 1, self.starArr:getSize() do
                self.starArr[i]:setEnable(false);
            end
        end
    end
end

function Lua_HeroAtlasCell:onPressClick()
    if self.data == nil then
        return;
    end
    Lua_MsgUtil.callFunc("SHOW_SELECT_HERO_WIND",self.data);
end