--英雄图鉴属性展示
checkRequire("Lua_HeroTabCell");
checkRequire("Lua_HeroShowBaseWindow");
Lua_HeroShowAtlasAttributeWindow = class("Lua_HeroShowAtlasAttributeWindow", Lua_HeroShowBaseWindow);
function Lua_HeroShowAtlasAttributeWindow:ctor()
    self:superCall("ctor");
    self.windowName = "Lua_HeroShowAtlasAttributeWindow";
end

function Lua_HeroShowAtlasAttributeWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.type_icon:setScale(0.85, 0.85, 1);
    self.type_icon:setLocation(-122, -42, 0);
    self.lock_btn:setEnable(false);
    self.rebuild_btn:setEnable(false);
    self.sub_btn:setEnable(false);
    self.add_btn:setEnable(false);
    LuaUtil.setObjPos(self.attr_obj, 0, 550, 0);
    
    self.sub_btn:addClickFuntion(self, self.onSubBtnClick);
    self.add_btn:addClickFuntion(self, self.onAddBtnClick);
    self.comment_btn:addClickFuntion(self, self.onCommentBtnClick);-- 评论
    self.introduce_btn:addClickFuntion(self, self.onIntroduceBtnClick);-- 传记

    self:addLuaEvent("UPDATE_HERO_ATLAS_INFO", self, self.updateShowPropInfo);-- 属性更新
    self:addLuaEvent("UPDATA_TAG_BUTTON_ITEM", self, self.onTabBtnClick);-- 页签按钮

    self.tabList = Lua_DragList.new(self.downObj, 118, 108, Lua_AxisDefine.Horizontal);
    self.tabList:setListCell(Lua_HeroTabCell, 118, 108, 1);
    self.tabList:setRectPivot(5);
    self.tabList:setLocation(358, 54);
end

function Lua_HeroShowAtlasAttributeWindow:onScreenResize()
    self:superCall("onScreenResize");
    if self.curPanel ~= nil then
        self.curPanel:setRectSize(self.width, self.height);
    end
end

--英雄展示数据
function Lua_HeroShowAtlasAttributeWindow:showWin(param)
    self:superCall("showWin", param);
    if param == nil then
        self:hide();
        return;
    end

    self.selectTabId = nil;
    self.selectBtn = param.selectBtn;--页签按钮

    if param.isShowTab == true then--仅展示当前英雄，可以左右切换展示别的英雄
        self.showArr = param.arr; --图鉴列表数据
        self.showIdx = param.createIdx;
    end
    
    local hvo = DataCenter.heroAtlasData:getAtlasVoById(param.aid).heroVo;
    self:updateShowHeroInfo(param.aid);
    self:updateShowTabBtnState(hvo);
    self:sendHeroAtlas(param.aid);
end

function Lua_HeroShowAtlasAttributeWindow:updateShowHeroInfo(aid)
    local data = DataCenter.heroAtlasData:getAtlasVoById(aid).heroVo;
    local len = 1;--默认1
    if self.showArr ~= nil then
        len = self.showArr:getSize();
    end
    if len == 1 then
        self.sub_btn:setEnable(false);
        self.add_btn:setEnable(false);
    else
        if self.showIdx == 1 then
            self.sub_btn:setEnable(false);
            self.add_btn:setEnable(true);
        elseif self.showIdx == len then
            self.sub_btn:setEnable(true);
            self.add_btn:setEnable(false);
        else
            self.sub_btn:setEnable(true);
            self.add_btn:setEnable(true);
        end
    end
    self.name.text = data.name;
    self.title.text = data.title;
    self.profession.text = data.career_des;
    self.type_icon:setAltas("common_altas_2", tostring(data.campSprite));

    self:showStarsItem(data); -- 显示星级
    self:showHeroMondel(data);-- 模型展示
end

function Lua_HeroShowAtlasAttributeWindow:updateShowPropInfo(aid)
    self.heroVo = DataCenter.heroAtlasData:getAtlasVoById(aid).heroVo;
    self.forceNum.num = self.heroVo.heroForce;
    -- 切换页签更新数据
    if self.curPanel ~= nil then
        self.curPanel:updateHeroPanelInfo(self.heroVo,true);
    end
end

-- 页签显示状态
function Lua_HeroShowAtlasAttributeWindow:updateShowTabBtnState(data)
    local selectTabId = self.selectBtn;
    if self.selectTabId ~= nil then
        selectTabId =  self.selectTabId;
    end
    local arr,curSelectIdx = DataCenter.heroUtil:updateTabInfo(data, selectTabId, true);
    local moveToIndex = curSelectIdx;
    local len = arr:getSize();
    if len < 4 then
        self.tabList:setContentRect(118*len, 108);
    else
        self.tabList:setContentRect(472, 108);
    end
    self.tabList:setArrayData(arr);
    self.tabList:setSelected(moveToIndex);
    self.tabList.canDrag = len > 4;
    self:onTabBtnClick(arr[moveToIndex]);
end

-- 页签处理
function Lua_HeroShowAtlasAttributeWindow:onTabBtnClick(tabVo)
    if tabVo.is_show_gray == true then
        OperateAlert.show(tabVo.show_tips);
        return;
    end
    if self.selectTabId == tabVo.id then
        return;
    end
    self.selectTabId = tabVo.id;
    self.attr_obj:SetActive(tabVo.id ~=4);

    local panelName = tabVo.panel;
    if self.panelName ~= panelName then
        if self.curPanel ~= nil then
            self.curPanel:dispose();
            self.curPanel = nil;
        end
        self.panelName = panelName;
        local showPanel = checkRequire(self.panelName);
        self.curPanel = showPanel.new(self.downObj);
    end
    if self.heroVo ~= nil then
        self.curPanel:updateHeroPanelInfo(self.heroVo,true);
    end
end

function Lua_HeroShowAtlasAttributeWindow:onSubBtnClick()
    if self.modelScenePanel == nil or self.modelScenePanel:checkShowComplete() ~= true then 
        return;
    end

    if self.showArr == nil then
        return;
    end

    if self.showIdx <= 1 then
        return;
    end
    self.showIdx = self.showIdx - 1;
    local aid = self.showArr[self.showIdx];
    self:updateShowHeroInfo(aid);
    self:sendHeroAtlas(aid);
end

function Lua_HeroShowAtlasAttributeWindow:onAddBtnClick()
    if self.modelScenePanel == nil or self.modelScenePanel:checkShowComplete() ~= true then 
        return;
    end

    if self.showArr == nil then
        return;
    end

    local len = self.showArr:getSize();
    if self.showIdx >= len then
        return;
    end

    self.showIdx = self.showIdx + 1;
    local aid = self.showArr[self.showIdx];
    self:updateShowHeroInfo(aid);
    self:sendHeroAtlas(aid);
end

--请求数据
function Lua_HeroShowAtlasAttributeWindow:sendHeroAtlas(aid)
    Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroAtlasAttr(aid);
end

--评论
function Lua_HeroShowAtlasAttributeWindow:onCommentBtnClick()
    Lua_WindowUtil.openWin("Lua_HeroCommentWindow", Lua_WinParam.ACTION_OPEN, self.heroVo);
end

function Lua_HeroShowAtlasAttributeWindow:onIntroduceBtnClick()
    Lua_WindowUtil.openWin("Lua_HeroBiographyWindow", Lua_WinParam.ACTION_OPEN, self.heroVo);
end

function Lua_HeroShowAtlasAttributeWindow:dispose()
    if self.tabInfo ~= nil then
        self.tabInfo:dispose();
        self.tabInfo:clear();
        self.tabInfo = nil;
    end

    if self.curPanel ~= nil then
        self.curPanel:dispose();
        self.curPanel = nil;
    end
    
    self.heroVo = nil;
    self.showArr = nil;
    self.panelName = nil;
    DataCenter.heroAtlasData.isSHowAtlas = nil;
    DataCenter.heroAtlasData:removeShowModel();
    self:superCall("dispose");
end