-- 装备展示item
Lua_HeroEquipItem = class("Lua_HeroEquipItem", Lua_DisplayObject); 
function Lua_HeroEquipItem:ctor(p, typeof)
    self.typeof = typeof;--英雄tips特殊设置
    self:superCall("ctor", p);
end

function Lua_HeroEquipItem:buildShowItem()
    self:superCall("buildShowItem");
    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setClick(self, self.onIconBtnClick);
end

function Lua_HeroEquipItem.Set:part(val)
    self._part = val;
end

function Lua_HeroEquipItem:setData(param, hvo)
    self.hvo = hvo;
    if type(param) == "number" then
        self.data = DataCenter.equipData:getEquipVoByUid(param);
    elseif type(param) == "table" then
        self.data = param;
    elseif param == nil then
        self.data = nil;
    end

    if self.data ~= nil then
        self.itemIcon:setData(self.data);
        self.itemIcon:setShadow(false);
        --替换红点状态
        if self.typeof == nil then
            local showState = DataCenter.equipData:checkEquipPartRedDot(self.data, self.hvo.campType);
            if showState == false and self.hvo.isShowFight == true then--上阵的英雄展示锻造红点
                --锻造红点状态
                showState = DataCenter.equipData:checkEquipForgeRedDot(self.data);
            end
            self.itemIcon:showRedPoint(showState);
        end
    else
        local sprite = "ui_zb_icon_0"..self._part;
        if self._part == 1 then--ui转换
            sprite = "ui_zb_icon_02";
        elseif self._part == 2 then
            sprite = "ui_zb_icon_01";
        end
        self.isUnlock = DataCenter.equipUtil:equipPartUnlock(self._part, hvo.level, hvo.star);
        
        self.itemIcon:setData(nil);
        self.itemIcon:setShadow(true,"hero_atlas_2", sprite);
        self.itemIcon:setIconBg("common_altas_1", "ui_common_itembg_07");
        self.itemIcon:setLock(not self.isUnlock,"runes_atlas","ui_fs_label_01");

        if self.typeof == nil then
            local showState = DataCenter.equipData:checkEquipChangeRedDot(self._part);
            self.itemIcon:showRedPoint(showState);
        end
    end

    if self.typeof == 1 then
        self.itemIcon:setCanClick(self.data~= nil);
    end
end

function Lua_HeroEquipItem:onIconBtnClick()
    if self.typeof == 1 then
        if self.data ~= nil then
            Lua_WindowUtil.openWin("Lua_EquipTipsWindow", Lua_WinParam.ACTION_OPEN, {data = self.data, isShowBtns = false});
        end
        return
    end

    if self.isUnlock == false then--未解锁
        local info = DataCenter.talentUtil:getEquipPartConfigInfo(self._part);
        if info.unlock_lvl > self.hvo.level then
            OperateAlert.show(LanUtil.formateStr(126713, tostring(info.unlock_lvl)));
        end
        if info.unlock_star > self.hvo.star then
            OperateAlert.show(LanUtil.formateStr(126739, tostring(info.unlock_star)));
        end
        return
    end
    
	if self.data == nil then
        if self.hvo.trial_state then
            OperateAlert.show("试用英雄不可培养");
            return;
        end
        Lua_WindowUtil.openWin("Lua_EquipChangeWindow", Lua_WinParam.ACTION_OPEN, {part = self._part, hero_uid = self.hvo.unique_id});
	else
        Lua_WindowUtil.openWin("Lua_EquipTipsWindow", Lua_WinParam.ACTION_OPEN, {data = self.data, hero_uid = self.hvo.unique_id, isShowBtns = self.hvo.trial_state == false});
	end
end

function Lua_HeroEquipItem:dispose()
    self.hvo = nil;
    self.data = nil;
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    self:superCall("dispose");
end