--装备
checkRequire("Lua_HeroRunesItem");
checkRequire("Lua_HeroEquipItem");
checkRequire("Lua_HeroTalentItem");
checkRequire("Lua_HeroTrialTipItem");
Lua_HeroEquipPanel = class("Lua_HeroEquipPanel", Lua_DisplayObject);
function Lua_HeroEquipPanel:ctor(p)
    self:superCall("ctor", p,"HeroEquipPanel_skin");
end

function Lua_HeroEquipPanel:buildShowItem()
	self:superCall("buildShowItem");
	self.showSunesArr = Array();
	local item;
	for i=1,2 do
		item = Lua_HeroRunesItem.new(self.content);
		item.part = i;
		item:setLocation(-247+(i-1)*500, -286.5, 0);
		self.showSunesArr:add(item);
	end

	self.showEquipArr = Array();
	local item;
	for i=1,4 do
		item = Lua_HeroEquipItem.new(self.content);
		item.part = i;
		item:setLocation(-247+(i-1)*167, -435, 0);
		self.showEquipArr:add(item);
	end

	self.showTalentArr = Array();
	local item;
	for i=1,2 do
		item = Lua_HeroTalentItem.new(self.content);
		item.part = i;
		item:setLocation(-78+(i-1)*165, -297, 0);
		self.showTalentArr:add(item);
	end

	self.worn_btn:addClickFuntion(self, self.onWornBtnClick);
    self.demount_btn:addClickFuntion(self, self.onDemountBtnClick);
    
    self:addLuaEvent("UPDATE_HERO_TAB_REDDOT", self, self.updateTalentInfo);--更新红点
    self:addLuaEvent("UPDATE_TALENT_PANEL_REDDOT_STATE", self, self.updateTalentInfo);--更新界面战技学习红点状态
end

function Lua_HeroEquipPanel:updateHeroPanelInfo(data)
    self.data = data;
    local list = data.equipInfo;
    for i=1,self.showEquipArr:getSize() do
    	self.showEquipArr[i]:setData(list[i], data);
    end

    local list = data.runsInfo;
    for i=1,self.showSunesArr:getSize() do
    	self.showSunesArr[i]:setData(list[i], data);
    end

    self:updateTalentInfo();

    self.demount_btn:setEnable(not data.trial_state);
    self.worn_btn:setEnable(not data.trial_state);
    self:showTrialTipItem(data.trial_state);

    if not data.trial_state then
    	local showState = DataCenter.equipData:checkEquipRedDotState(data, false);--一键穿戴
    	self:showRedDot(showState);
	end
end

--更新战技
function Lua_HeroEquipPanel:updateTalentInfo()
	local list = self.data.talentInfo;
    for i=1,self.showTalentArr:getSize() do
    	self.showTalentArr[i]:setData(list[i], self.data);
    end
end

--一键穿戴红点
function Lua_HeroEquipPanel:showRedDot(val)
    if val == true then
        if self.redDotIcon == nil then
            self.redDotIcon = Lua_RedPointIcon.new(self.content);
            self.redDotIcon:setLocation(270, -524, 0);
            self.redDotIcon:createRedPointImg(nil);
        end
        self.redDotIcon:updateRedPointShow(true);
    else
        if self.redDotIcon ~= nil then
            self.redDotIcon:updateRedPointShow(false);
        end
    end
end

--显示试用英雄提示Item
function Lua_HeroEquipPanel:showTrialTipItem(val)
    if val then 
        if self.trialTipItem == nil then
            self.trialTipItem = Lua_HeroTrialTipItem.new(self.content);
            self.trialTipItem:setLocation(0, -520, 0);
        end
        self.trialTipItem:setData(self.data);
        self.trialTipItem:setEnable(true);
    else
        if self.trialTipItem ~= nil then
            self.trialTipItem:setData(nil);
            self.trialTipItem:setEnable(false);
        end
   end
end

--一键穿戴
function Lua_HeroEquipPanel:onWornBtnClick()
	local isWornEruip = #self.data.equip_info == 0;
	if isWornEruip == true and DataCenter.equipData.equipPackUidArr:getSize() == 0 then
		OperateAlert.showLangValue(126716);--暂无可穿戴装备
		return
	end
	local isshowDes = false;--待完善
	if isshowDes == true then
		OperateAlert.showLangValue(126717);--已是当前最强力装备
		return
	end
	Lua_ProxyManager.getProxy("Lua_EquipProxy"):sEquipChange(self.data.unique_id, 1); -- 一键卸下
end

--一键卸下
function Lua_HeroEquipPanel:onDemountBtnClick()
	local isWornEruip = #self.data.equip_info == 0;
	if isWornEruip == true then
		OperateAlert.showLangValue(126715);
		return
	end
	Lua_ProxyManager.getProxy("Lua_EquipProxy"):sEquipChange(self.data.unique_id,2); -- 一键卸下
end

function Lua_HeroEquipPanel:dispose()
	if self.showEquipArr ~= nil then
		self.showEquipArr:dispose();
		self.showEquipArr:clear();
		self.showEquipArr = nil;
	end
	if self.showSunesArr ~= nil then
		self.showSunesArr:dispose();
		self.showSunesArr:clear();
		self.showSunesArr = nil;
	end
	if self.showTalentArr ~= nil then
		self.showTalentArr:dispose();
		self.showTalentArr:clear();
		self.showTalentArr = nil;
	end

	if self.redDotIcon ~= nil then
        self.redDotIcon:dispose();
        self.redDotIcon = nil;
    end
	self:superCall("dispose");
end