-- 符文展示item
Lua_HeroRunesItem = class("Lua_HeroRunesItem", Lua_DisplayObject); 
function Lua_HeroRunesItem:ctor(p, typeof)
    self.typeof = typeof;--英雄tips特殊设置
    self:superCall("ctor", p);
end

function Lua_HeroRunesItem:buildShowItem()
    self:superCall("buildShowItem");
    self.bootom_bg = UICreate.createUIAtlasImage(self.content, "runes_atlas", "ui_fs_window_002", 0, 0, 0, 0);

    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setClick(self, self.onIconBtnClick);
end

function Lua_HeroRunesItem.Set:part(val)
    self._part = val;
end

function Lua_HeroRunesItem:setData(param, hvo)
    self.hvo = hvo;
    if type(param) == "number" or param == nil then
        self.data = DataCenter.runesData:getRunesVoByUid(param);
    elseif type(param) == "table" then
        self.data = param;
    elseif param == nil then
        self.data = nil;
    end
    self.isUnlock = DataCenter.runesUtil:RunesPartUnlock(self._part, hvo.level, hvo.star);
    if self.data ~= nil then
        self.itemIcon:setData(self.data);
        self.itemIcon:setShadow(false);
    else
        self.itemIcon:setData(nil);
        self.itemIcon:setShadow(self.isUnlock,"hero_atlas_2", "ui_zb_icon_02");
        self.itemIcon:setIconBg("common_altas_1", "ui_common_itembg_07");
        self.itemIcon:setLock(not self.isUnlock,"common_altas_1","ui_fs_label_01");
    end

    if self.typeof == nil then
        local redPointState = DataCenter.runesData:checkPartRedDotState(self._part, hvo);
        self.itemIcon:showRedPoint(redPointState);
    else
        self.itemIcon:setCanClick(self.data ~= nil);
    end
end

function Lua_HeroRunesItem:onIconBtnClick()
    if self.typeof == 1 then
        if self.data ~= nil then
            Lua_WindowUtil.openWin("Lua_RunesTipsWindow", Lua_WinParam.ACTION_OPEN, {part = self._part, hero_uid = self.hvo.unique_id, data = self.data, isShowBtns = false});
        end
        return
    end

    if self.isUnlock == false then
        local info = DataCenter.runesUtil:getRunesPartConfigInfo(self._part);
        if info.unlock_lvl > self.hvo.level or info.unlock_star > self.hvo.star then
            if self._part == 1 then
                OperateAlert.show(LanUtil.formateStr(126854, tostring(info.unlock_lvl)));
            else
                OperateAlert.show(LanUtil.formateStr(126855, tostring(info.unlock_lvl), tostring(info.unlock_star)));
            end
        end
        return
    end
    
	if self.data == nil then
        if self.hvo.trial_state then
            OperateAlert.showLangValue(126851);
            return;
        end
        Lua_WindowUtil.openWin("Lua_RunesChangeWindow", Lua_WinParam.ACTION_OPEN, {part = self._part, hero_uid = self.hvo.unique_id});
	else
        if self.hvo.trial_state then
            Lua_WindowUtil.openWin("Lua_RunesTipsWindow", Lua_WinParam.ACTION_OPEN, {part = nil, hero_uid = self.hvo.unique_id, data = self.data, isShowBtn = false});
            return;
        end
        Lua_WindowUtil.openWin("Lua_RunesTipsWindow", Lua_WinParam.ACTION_OPEN, {part = self._part, hero_uid = self.hvo.unique_id, data = self.data, isShowBtns = true});
	end
end

function Lua_HeroRunesItem:dispose()
    self.bootom_bg = nil;
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    if self.redDotIcon ~= nil then
        self.redDotIcon:dispose();
        self.redDotIcon = nil;
    end
    self.hvo = nil;
    self.data = nil;
    self:superCall("dispose");
end