-- 英雄时装
Lua_HeroFashionPanel = class("Lua_HeroFashionPanel", Lua_DisplayObject);
function Lua_HeroFashionPanel:ctor(p)
    self:superCall("ctor", p,"HeroFashionPanel_skin");
end

function Lua_HeroFashionPanel:buildShowItem()
	self:superCall("buildShowItem");

    self.sub_btn:setEnable(false);
    self.attr_des:setEnable(false);
    self.sub_btn:addClickFuntion(self, self.onSubBtnClick);
    self:addLuaEvent("ON_FASHION_ITEM", self, self.onFashionItem);--时装点击
    self:addLuaEvent("UPDATE_HERO_FASHION_INFO", self, self.updatePanelInfo);--更新

    self.dragList = Lua_DragList.new(self.content, 620, 275, Lua_AxisDefine.Horizontal);
    self.dragList:setListCell(Lua_HeroFashionCell, 201, 275, 1);
    self.dragList:setCellSpacing(10, 10);
    self.dragList:setLocation(0, -275);
    self.dragList.canDrag = false;
end

function Lua_HeroFashionPanel:updateHeroPanelInfo(data,isSHowAtlas)
    self.data = data;
    local arr = data.heroFashionInfo;
    self.dragList:setArrayData(arr);
    local index;
    if isSHowAtlas == true then
        index = 1;
        self.fengxian:setEnable(false);
        self.isSHowAtlas = isSHowAtlas;--图鉴
        DataCenter.heroAtlasData.isSHowAtlas = true;
        LuaUtil.setObjPos(self.content, 0, 630, 0);
    else
        index = DataCenter.heroData:getUseFashionIndex(arr);
    end
    self.dragList:moveToIndex(index);
    self.dragList:setSelected(index);
    self:onFashionItem(arr[index]);
end

function Lua_HeroFashionPanel:updatePanelInfo()
    local arr = self.data.heroFashionInfo;
    self.dragList:setArrayData(arr);
    if self.selectIndex == nil then
        self.selectIndex =1;
    end
    self:onFashionItem(arr[self.selectIndex]);
end

function Lua_HeroFashionPanel:onFashionItem(data)
    self.selectIndex = data.index;
    if self.isSHowAtlas == nil then
        self.fashionVo = data;
        self.des:setEnable(data.is_initial ~=1);
        if data.isUseClothes == true then--已穿戴
            self.sub_btn:setEnable(false);
        else
            self.sub_btn:setEnable(true);
            if data.is_activate == 1 then --已激活
                self.sub_btn:setLangValue(126502);
            else
                if data.config.is_initial == 1 then
                    self.sub_btn:setLangValue(126502);
                else
                    self.sub_btn:setLangValue(126500);
                end
            end
        end
    end

    self.attr_des.text = data.config.attr_des;
    self.attr_des:setEnable(true);
    if data.fashionRedDot == true then
        Lua_ProxyManager.getProxy("Lua_HeroProxy"):sFashionRedDot(self.data.id, data.id);
    end
end

function Lua_HeroFashionPanel:onSubBtnClick()
    if self.fashionVo.is_activate == 1 then --已激活点击穿戴
        local id  = self.fashionVo.id
        if self.fashionVo.config.is_initial == 1 then
            id = 0;
        end
        Lua_ProxyManager.getProxy("Lua_HeroProxy"):sUseFashion(self.data.unique_id, id);
    else--点击打开获取途径
        DataCenter.packUtil:openPathWindow(self.fashionVo.id, false);
    end
end

function Lua_HeroFashionPanel:dispose()
    if self.dragList ~= nil then
        self.dragList:dispose();
        self.dragList = nil;
    end
    self.data = nil;
    self.fashionVo = nil;
    self:superCall("dispose");
end











Lua_HeroFashionCell = class("Lua_HeroFashionCell", Lua_ListCell);
function Lua_HeroFashionCell:ctor(p)
    self:superCall("ctor", p,"HeroFashionCell_skin");
end

function Lua_HeroFashionCell:buildShowItem()
    self:superCall("buildShowItem");
    self.isStarTime = false;
end

function Lua_HeroFashionCell:setData(data)
    if data == nil then
        return;
    end
    self.data = data;
    self.name.text = data.name;
    self.show_img:setUrl(data.path);
    if DataCenter.heroAtlasData.isSHowAtlas == true then--图鉴
        self.time:setEnable(false);
        self.state:setEnable(false);
    else
        if data.is_activate == 1 then
            self.show_img.alpha = 1;
            self.state:setEnable(data.isUseClothes);
            if self.isStarTime == false and data.tick ~= 0 then
                self.isStarTime = true;
                self.time.text = Lua_TimeTransform.transSeconds18(self.data.showTime,nil,nil,nil,true);
                Lua_CommonUtil.addTimer("updataFashionControlTime", 1, self, self.updataFashionControlTime);
            else
                self.time:setLangValue(126504);
                self.isStarTime = false;
                Lua_CommonUtil.removeTimer(self,self.updataFashionControlTime);
            end
        else
            self.show_img.alpha = 0.5;
            self.state:setEnable(false);
            self.time:setLangValue(126505);
        end
        self:showRedDot(data.fashionRedDot);
    end
end

--红点
function Lua_HeroFashionCell:showRedDot(val)
    if val == true then
        if self.redDotIcon == nil then
            self.redDotIcon = Lua_RedPointIcon.new(self.content);
            self.redDotIcon:setLocation(85, 122, 0);
            self.redDotIcon:createRedPointImg(nil);
        end
        self.redDotIcon:updateRedPointShow(true);
    else
        if self.redDotIcon ~= nil then
            self.redDotIcon:updateRedPointShow(false);
        end
    end
end

function Lua_HeroFashionCell:updataFashionControlTime()
    local showTime = self.data.showTime;
    if showTime > 0 then
        self.time.text = Lua_TimeTransform.transSeconds18(showTime,nil,nil,nil,true);
    else
        self.time:setLangValue(126505);
        self.isStarTime = false;
        self.show_img.alpha = 0.5;
        Lua_CommonUtil.removeTimer(self,self.updataFashionControlTime);
    end
end

function Lua_HeroFashionCell:onPressClick()
    Lua_MsgUtil.callFunc("ON_FASHION_ITEM", self.data);
end

function Lua_HeroFashionCell:dispose()
    self.isStarTime = false;
    Lua_CommonUtil.removeTimer(self,self.updataFashionControlTime);
    self:superCall("dispose");
end