Lua_HeroMaterialItem = class("Lua_HeroMaterialItem", Lua_DisplayObject);
function Lua_HeroMaterialItem:ctor(p)
	self:superCall("ctor", p)
end

function Lua_HeroMaterialItem:buildShowItem()
	self:superCall("buildShowItem")

	self.itemIcon = Lua_ItemIcon.new(self.content)
	self.itemIcon:setCanClick(true)
	self.itemIcon:setClick(self, self.onClick)

	self.countText = UICreate.createLabel(self.content, nil, 0, -77, 100, 31, 24)
	self.countText.pivotValue = 4
	self.countText.alignmentValue = 4
	self.countText.fontName = Lua_MyUISettings.fangzhengFontName
	self.countText.horizontalOverflowValue = 1
	self.countText.verticalOverflowValue = 0
	self.countText.colorStr = Lua_ColorDefine.transColorStr("B8C5C3")
end

function Lua_HeroMaterialItem:dispose()
	if self.itemIcon then
		self.itemIcon:dispose()
		self.itemIcon = nil
	end
	self.data = nil
	self:superCall("dispose")
end

function Lua_HeroMaterialItem:showAdd(bState)
	if bState then
		if self.addIcon == nil then
			self.addIcon = UICreate.createUIAtlasImage(self.content, "hero_altas_1", "ui_hb_button_004_n", 35, -37, 0, 0)
			self.addIcon:addClickFuntion(self, self.onClick)
		end
		self.addIcon:setEnable(true)
	else
		if self.addIcon then
			self.addIcon:setEnable(false)
		end
	end
end

function Lua_HeroMaterialItem:setData(data)
	self.data = data
	self.itemIcon:setData(data.heroVo)
	self:updateNum()
end

function Lua_HeroMaterialItem:updateNum()
	local selectedNum = DataCenter.heroMaterialData:getSelectedNum(self.data.index)
	if selectedNum >= self.data.num then
		self:showAdd(false)
		self.itemIcon:setGray(false)
		self.itemIcon:showRedPoint(false)
		self.countText.text = LanUtil.formateStr(10044, Lua_ColorDefine.getColorStr("16A803", selectedNum), tostring(self.data.num))
	else
		self:showAdd(true)
		self.itemIcon:setGray(true)
		self.itemIcon:showRedPoint(DataCenter.heroMaterialData:checkEnoughByVo(self.data))
		self.countText.text = LanUtil.formateStr(10044, Lua_ColorDefine.getColorStr("DE4A16", selectedNum), tostring(self.data.num))
	end
end

function Lua_HeroMaterialItem:onClick()
	Lua_WindowUtil.openWin("Lua_HeroMaterialSelectWindow", Lua_WinParam.ACTION_OPEN, self.data)
end