Lua_HeroMaterialSelectWindow = class("Lua_HeroMaterialSelectWindow", Lua_Window);
function Lua_HeroMaterialSelectWindow:ctor()
	self:superCall("ctor");
	
	self.windowName = "Lua_HeroMaterialSelectWindow"
	self.skinName = "HeroMaterialSelectWindow_skin"
	self.showBlackMask = true
	self.isClickClose = true
end

function Lua_HeroMaterialSelectWindow:buildShowItem()
	self:superCall("buildShowItem")
	self:addLuaEvent("HERI_MATERIAL_SELECT", self, self.onMaterialSelected)

	self.itemList = Lua_DragList.new(self.content, 644, 505, Lua_AxisDefine.Vertical)
	self.itemList:setLocation(0, 90)
	self.itemList:setListCell(Lua_HeroMaterialSelectItem, 158, 229, 4)
	self.itemList:setCellSpacing(4, 8)

	self.btnSure:addClickFuntion(self, self.onBtnSureClick)
end

function Lua_HeroMaterialSelectWindow:dispose()
	if self.itemList then
		self.itemList:dispose()
		self.itemList = nil
	end
	self.selectedDic = nil
	self:superCall("dispose")
end

function Lua_HeroMaterialSelectWindow:showWin(param)
	self:superCall("showWin", param)

	local arr = DataCenter.heroMaterialData:getHeroList(param)
	arr:add({ heroId = param.id })
	self.itemList:setArrayData(arr)

	self.selectedDic = DataCenter.heroMaterialData:record()
	self:updateShowInfo()
end

function Lua_HeroMaterialSelectWindow:updateShowInfo(selectedNum)
	if selectedNum == nil then
		selectedNum = DataCenter.heroMaterialData:getSelectedNum(self.showData.index)
	end
	self.selectedText.text = LanUtil.formateStr(126215, tostring(selectedNum), tostring(self.showData.num))
end

function Lua_HeroMaterialSelectWindow:onMaterialSelected(data)
	if DataCenter.heroMaterialData:isSelectedHero(data) then
		DataCenter.heroMaterialData:removeHero(self.showData.index, data)
	else
		local selectedNum = DataCenter.heroMaterialData:getSelectedNum(self.showData.index)
		if selectedNum == self.showData.num then
			OperateAlert.showLangValue(126208)
			return
		else
			DataCenter.heroMaterialData:addHero(self.showData.index, data)
		end
	end

	self:updateShowInfo(selectedNum)
	self.itemList:updateShowList()
end

function Lua_HeroMaterialSelectWindow:onBtnSureClick(go)
	Lua_MsgUtil.callFunc("UPDATE_HERI_MATERIAL_SELECT", self.showData.index)
	self:hide()
end

function Lua_HeroMaterialSelectWindow:onBtnCloseClick(go)
	DataCenter.heroMaterialData:revert(self.selectedDic)
	self:superCall("onBtnCloseClick", go)
end

function Lua_HeroMaterialSelectWindow:onMaskClick(go)
	DataCenter.heroMaterialData:revert(self.selectedDic)
	self:superCall("onMaskClick", go)
end




















Lua_HeroMaterialSelectItem = class("Lua_HeroMaterialSelectItem", Lua_ListCell)
function Lua_HeroMaterialSelectItem:ctor(p)
    self:superCall("ctor", p)
end

function Lua_HeroMaterialSelectItem:buildShowItem()
	self:superCall("buildShowItem")

    self.heroItemIcon = Lua_HeroItemIcon.new(self.content)
    self.heroItemIcon:setScale(0.92, 0.92)
end

function Lua_HeroMaterialSelectItem:dispose()
	if self.heroItemIcon then
		self.heroItemIcon:dispose()
		self.heroItemIcon = nil
	end
	self.data = nil
	self.heroVo = nil
	self:superCall("dispose")
end

function Lua_HeroMaterialSelectItem:setData(data)
	self.data = data
	self:updateData()
end

function Lua_HeroMaterialSelectItem:updateData()
	if type(self.data) == "number" then
		self.heroVo = DataCenter.heroData:getItemByUniqueId(self.data)
		self.heroItemIcon:setData(self.heroVo)
		if DataCenter.heroMaterialData:isSelectedHero(self.data) == true then
			self.heroItemIcon:setLock(false)
			self.heroItemIcon:setMask(true)
			self.heroItemIcon:setTick(true)
		elseif self.heroVo.lock_state == true or self.heroVo.isUpLineup == true then
			self.heroItemIcon:setLock(true)
			self.heroItemIcon:setMask(true)
			self.heroItemIcon:setTick(false)
		else
			self.heroItemIcon:setLock(false)
			self.heroItemIcon:setMask(false)
			self.heroItemIcon:setTick(false)
		end
		self.heroItemIcon:setAdd(false)
	else
		self.heroVo = nil
		self.heroItemIcon:setData(nil)
		self.heroItemIcon:setLock(false)
		self.heroItemIcon:setMask(false)
		self.heroItemIcon:setTick(false)
		self.heroItemIcon:setAdd(true)
	end
end

function Lua_HeroMaterialSelectItem:onPressClick()
	if self.heroVo == nil then
		local data = Lua_HeroConfigData.getConfig(self.data.heroId)
		DataCenter.packUtil:openPathWindow(data.itemId, false)
		return
	end

	if not DataCenter.heroUpStarData:showSelectHeroLimitTips(self.heroVo, true) then
		return
	end

	if self.heroVo.isTalent and not DataCenter.heroMaterialData:isSelectedHero(self.heroVo.unique_id) then
		self:showTalentTips()
	else
		self:onSureFun()
	end
end

function Lua_HeroMaterialSelectItem:showTalentTips()
	local tipsData = {
		h = 443, font_size = 26, des = LanUtil.getValue(126217), posY = 44, 
		btnType = 1, owner = self, sureFun = self.onSureFun
	}
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_HeroMaterialSelectItem:onSureFun()
    Lua_MsgUtil.callFunc("HERI_MATERIAL_SELECT", self.heroVo.unique_id)
end