-- 英雄升星材料选择
Lua_HeroSelectCostWindow = class("Lua_HeroSelectCostWindow", Lua_Window);
function Lua_HeroSelectCostWindow:ctor()
	self:superCall("ctor");
    self.isClickClose = true;
    self.showBlackMask = true;
	self.windowName = "Lua_HeroSelectCostWindow";
	self.skinName = "HeroSelectCostWindow_skin";
end

function Lua_HeroSelectCostWindow:buildShowItem()
	self:superCall("buildShowItem");

    self:addLuaEvent("UPDATA_SELECT_HERO_ITEM", self, self.updataSelectItemInfo); -- 选择单个英雄返回

	self.dragList = Lua_DragList.new(self.content, 644, 505, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_HeroSelectCostCell, 158, 229, 4);
    self.dragList:setCellSpacing(4, 8);
    self.dragList:setLocation(0, 90);

    self.sub_btn:addClickFuntion(self, self.onSubClick);
    self.select_btn:addClickFuntion(self, self.onAllSelectClick);
    -- self:addLuaEvent("UPDATE_STAR_INFO", self, self.updateSelectCostInfo);
end

-- 英雄展示数据
function Lua_HeroSelectCostWindow:showWin(param)
    self.upStarCostVo = param;
    self.costMaterialsIndex = param.costMaterialsIndex;

    if self.upStarCostVo.star <= DataCenter.heroUtil.up_star_limit then
        self.sub_btn:setLocation(144, -240, 0);
        self.select_btn:setEnable(true);
    end
    self.costItemsInfo = DataCenter.heroUpStarData:showHeroInfo(param);
    self.dragList:setArrayData(self.costItemsInfo);
    self.tagUidDic, self.tagCostIndexInfo = DataCenter.heroUpStarData:tagInitInfo();--记录初始数据
    self:updateSelectCostNum();
end

function Lua_HeroSelectCostWindow:updateSelectCostNum()
    local selectNum = DataCenter.heroUpStarData:getSelectHeroNumByIndex(self.upStarCostVo.costMaterialsIndex);
    self.select_num.text = LanUtil.formateStr(126215, tostring(selectNum), tostring(self.upStarCostVo.needNum));
end

function Lua_HeroSelectCostWindow:updataSelectItemInfo(unique_id) -- 选择道具数据
    self.unique_id = unique_id;
    if DataCenter.heroUpStarData:isSelectHeroUidByUid(unique_id) == true then
        DataCenter.heroUpStarData:delSelectedUidState(self.costMaterialsIndex, unique_id);
    else
        local selectNum = DataCenter.heroUpStarData:getSelectHeroNumByIndex(self.costMaterialsIndex);
        if selectNum == self.upStarCostVo.needNum then
            OperateAlert.showLangValue(126208);
            return;
        else
            local hvo = DataCenter.heroData:getItemByUniqueId(unique_id);
            if hvo ~= nil and hvo.initial_star == 5 and hvo.rarity >= 5 and self.upStarCostVo.id == 0 then
                self:showTips();
                return
            else
                self:updateSelectInfo(unique_id);
            end
        end
    end
    self:updateSelect();
    self:updateSelectCostNum();
end

function Lua_HeroSelectCostWindow:updateSelectInfo(unique_id)
    -- print(self.costMaterialsIndex," unique_id = =",unique_id)
    DataCenter.heroUpStarData:addSelectedUidState(self.costMaterialsIndex, unique_id);
end

function Lua_HeroSelectCostWindow:showTips()
    local tipData = { des = LanUtil.getValue(126207), btnType = 1, owner = self, sureFun = self.onSubBtnClick };
    Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_HeroSelectCostWindow:onSubBtnClick()
    self:updateSelectInfo(self.unique_id);
    self:updateSelect();
    self:updateSelectCostNum();
end

function Lua_HeroSelectCostWindow:updateSelect()
    if self.dragList ~= nil then
        local arr = self.dragList.showList;
        local len = arr:getSize();
        for i = 1, len do
            arr[i]:updateSelect();
        end
    end
end

function Lua_HeroSelectCostWindow:onAllSelectClick() -- 一键选择
    local selectNum = DataCenter.heroUpStarData:getSelectHeroNumByIndex(self.costMaterialsIndex);
    if selectNum == self.upStarCostVo.needNum then
        OperateAlert.showLangValue(126208);
        return;
    end

    if self.costItemsInfo:getSize() == 0 then
        OperateAlert.showLangValue(126210);
        return;
    end

    if self.dragList ~= nil then
        local length;
        local tagNum = 0;
        local needNum = self.upStarCostVo.needNum - selectNum;

        local arr = self.costItemsInfo;
        local len = arr:getSize();
        for i = 1, len do
            local isSeleect = DataCenter.heroUpStarData:isSelectHeroUidByIndex(self.costMaterialsIndex,arr[i]);
            local isSpecialState = false;--是否存在特殊状态，（特殊状态无法被选中）
            length = string.len(arr[i]);
            if length >= 20 then--万能道具
                isSpecialState = false;
            else--英雄
                isSpecialState = DataCenter.heroData:getItemByUniqueId(arr[i]).isSpecialState;
            end
            if isSeleect == false and isSpecialState == false then
                if tagNum <= needNum then
                    tagNum = tagNum + 1;
                    self:updateSelectInfo(arr[i]);
                    if tagNum == needNum then
                        break;
                    end
                end
            end
        end
    end
    self:updateSelect();
    self:updateSelectCostNum();
end

function Lua_HeroSelectCostWindow:onSubClick() -- 确定
    Lua_MsgUtil.callFunc("UPDATA_SELECT_COST_HERO_NUM",self.costMaterialsIndex);
    self:hide();
end

function Lua_HeroSelectCostWindow:onBtnCloseClick(go)
    DataCenter.heroUpStarData:updateTagInitInfo(self.tagUidDic, self.tagCostIndexInfo);
    self:hide();
end

function Lua_HeroSelectCostWindow:onMaskClick(go)
    DataCenter.heroUpStarData:updateTagInitInfo(self.tagUidDic, self.tagCostIndexInfo);
    self:hide();
end


function Lua_HeroSelectCostWindow:dispose()
    if self.dragList ~= nil then
        self.dragList:dispose();
        self.dragList = nil;
    end
    self.upStarCostVo = nil;
    self.tagUidDic = nil;
    self.tagCostIndexInfo = nil;
    self:superCall("dispose");
end
















-- 英雄升星选择Item
Lua_HeroSelectCostCell = class("Lua_HeroSelectCostCell", Lua_ListCell);
function Lua_HeroSelectCostCell:ctor(p)
    self:superCall("ctor", p);
end

function Lua_HeroSelectCostCell:buildShowItem()
	self:superCall("buildShowItem");

    self.heroItemIcon = Lua_HeroItemIcon.new(self.content);
    self.heroItemIcon:setScale(0.92,0.92);

    self.mask = UICreate.createUIAtlasImage(self.content, "hero_altas_1", "ui_hb_window_007", 0, 0, 157, 231);
    self.mask:setEnable(false);

    self.select = UICreate.createUIAtlasImage(self.content, "hero_altas_1", "ui_hb_window_010", 0, 0, 72, 71);
    self.select:setEnable(false);

    self.lock = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_button_018_n", 0, 0, 0, 0);
    self.lock:setEnable(false);
end

function Lua_HeroSelectCostCell:setData(unique_id)
    self.unique_id = unique_id;
    local len = string.len(unique_id);
    if len >= 20 then
        local item_id = string.sub(unique_id,1,9);
        self.vo = Lua_ToolVo.new(item_id);
    else
        self.vo = DataCenter.heroData:getItemByUniqueId(unique_id);
    end

    self.heroItemIcon:setData(self.vo);

	self:updateSelect()
end

function Lua_HeroSelectCostCell:updateSelect()
    -- print("更新   =- =",self.data.unique_id)
    if DataCenter.heroUpStarData:isSelectHeroUidByUid(self.unique_id) == true then
        self.mask:setEnable(true);
        self.lock:setEnable(false);
        self.select:setEnable(true);
    else
        self.select:setEnable(false);
        if self.vo.lock_state == true or self.vo.isUpLineup == true then
            self.lock:setEnable(true);
            self.mask:setEnable(true);
        else
            self.mask:setEnable(false);
            self.lock:setEnable(false);
        end
    end 
end

function Lua_HeroSelectCostCell:onPressClick(go)
    if self.vo == nil then
        return;
    end
    if not DataCenter.heroUpStarData:showSelectHeroLimitTips(self.vo, true) then
        return
    end

    if self.vo.isTalent and DataCenter.heroUpStarData:isSelectHeroUidByUid(self.unique_id) ~= true  then
        self:showTalentTips();
    else
        self:onSureBtnClick();
    end
end

function Lua_HeroSelectCostCell:onSureBtnClick()
    Lua_MsgUtil.callFunc("UPDATA_SELECT_HERO_ITEM", self.unique_id);
end

--遗忘战技tips
function Lua_HeroSelectCostCell:showTalentTips()
    local tipData = {
        h = 443,
        font_size = 26,
        des = LanUtil.getValue(126217),
        posY = 44,
        btnType = 1,
        owner = self,
        sureFun = self.onSureBtnClick
    };
    Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_HeroSelectCostCell:dispose()
    self.data = nil;
    if self.starInfo ~= nil then
        self.starInfo:dispose();
        self.starInfo:clear();
        self.starInfo = nil;
    end
    self.mask = nil;
    self.lock = nil;
    self.select = nil;
    self:superCall("dispose");
end