-- 英雄升星成功Tips
checkRequire("Lua_HeroShowAttributeItem");
Lua_HeroUpStarSucceedWindow = class("Lua_HeroUpStarSucceedWindow", Lua_Window);
function Lua_HeroUpStarSucceedWindow:ctor()
    self:superCall("ctor");
    self.showClose = false;
    self.windowName = "Lua_HeroUpStarSucceedWindow";
    self.skinName = "HeroUpStarSucceedWindow_skin";
end

function Lua_HeroUpStarSucceedWindow:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_HeroUpStarSucceedWindow:showWin(param)
    local str = DataCenter.heroUtil:getHeroStarConfigInfo(param.data.star).add_lvl_limit;
    self.limit_des.text =  LanUtil.formateStr(126204, tostring(str));
    self:showLeftStarsItem(param.data.star-1);
    self:showRightStarsItem(param.data);
    self:showAttributes(param.data,param.attrDic);
end

-- 属性展示
function Lua_HeroUpStarSucceedWindow:showAttributes(data, prop_list)
    local info = DataCenter.heroData:showAttrInfo(data, prop_list);
    if info ~= nil then
        if self.attrInfo == nil then
            self.attrInfo = Array();
        end
        local len = self.attrInfo:getSize();
        for i = 1, len do
            self.attrInfo[i]:setEnable(false);
        end
        for i = 1, info:getSize() do
            local item = nil;
            if self.attrInfo[i] ~= nil then
                item = self.attrInfo[i];
            else
                item = Lua_HeroShowAttributeItem.new(self.content);
                self.attrInfo:add(item);
            end
            item:setData(info[i]);
            item:setLocation(0,40 - (i-1)*50, 0);
            item:setEnable(true);
        end
    else
        if self.attrInfo ~= nil then
            local len = self.attrInfo:getSize();
            for i = 1, len do
                self.attrInfo[i]:setEnable(false);
            end
        end
    end
end

function Lua_HeroUpStarSucceedWindow:showLeftStarsItem(val) -- 显示星级
    local star
    if val > 0 then
        if val < 10 then
            star = val % 5;
            star = star == 0 and 5 or star;
        else
            star = 1;
        end
    else
        star = 0;
    end
    if star > 0 then
        local sn = DataCenter.heroUtil:getStarSprite(val,2);
        if self.leftStars == nil then
            self.leftStars = Array();
        end
        local starWidth = 45;
        local len = self.leftStars:getSize();
        for i = 1, len do
            self.leftStars[i]:setEnable(false);
        end
        for i = 1, star do
            local item = nil;
            if self.leftStars[i] ~= nil then
                item = self.leftStars[i];
            else
                item = UICreate.createUIAtlasImage(self.upObject, "iconantlas1", "common_widget_024", 0, 0, 28, 28);
                self.leftStars:add(item);
            end
            item:setDepth(10 + i);
            item:setLocation(125+i*27, -70, 0);
            item:setAltas("iconantlas1", sn);
            item:setEnable(true);
        end
    else
        if self.leftStars ~= nil then
            local len = self.leftStars:getSize();
            for i = 1, len do
                self.leftStars[i]:setEnable(false);
            end
        end
    end
end

function Lua_HeroUpStarSucceedWindow:showRightStarsItem(data) -- 显示星级
    if data ~= nil then
        local star = data.showStar;
        local sn = DataCenter.heroUtil:getStarSprite(data.star,2);
        
        if self.rightStars == nil then
            self.rightStars = Array();
        end
        local starWidth = 45;
        local len = self.rightStars:getSize();
        for i = 1, len do
            self.rightStars[i]:setEnable(false);
        end
        for i = 1, star do
            local item = nil;
            if self.rightStars[i] ~= nil then
                item = self.rightStars[i];
            else
                item = UICreate.createUIAtlasImage(self.upObject, "iconantlas1", "common_widget_024", 0, 0, 28, 28);
                self.rightStars:add(item);
            end
            item:setDepth(10 + i);
            item:setLocation(-286+ i*27, -70, 0);
            item:setAltas("iconantlas1", sn);
            item:setEnable(true);
        end
    else
        if self.rightStars ~= nil then
            local len = self.rightStars:getSize();
            for i = 1, len do
                self.rightStars[i]:setEnable(false);
            end
        end
    end
end

function Lua_HeroUpStarSucceedWindow:dispose()
    if self.leftStars ~= nil then
        self.leftStars:dispose();
        self.leftStars:clear();
        self.leftStars = nil;
    end

    if self.rightStars ~= nil then
        self.rightStars:dispose();
        self.rightStars:clear();
        self.rightStars = nil;
    end

    if self.attrInfo ~= nil then
        self.attrInfo:dispose();
        self.attrInfo:clear();
        self.attrInfo = nil;
    end
    
    self.data = nil;
    self:superCall("dispose");
end