-- 英雄升星
checkRequire("Lua_HeroCostItem");
checkRequire("Lua_HeroUpStarCostItem");
Lua_HeroUpStarPanel = class("Lua_HeroUpStarPanel", Lua_DisplayObject);
function Lua_HeroUpStarPanel:ctor(p)
    self:superCall("ctor", p, "HeroUpStarPanel_skin");
end

function Lua_HeroUpStarPanel:buildShowItem()
    self:superCall("buildShowItem");

    self.left_star_bg:setEnable(false);
    self.left_star_level:setEnable(false);
    self.right_star_bg:setEnable(false);
    self.right_star_level:setEnable(false);
    self.tree_des:setEnable(false);

    self.star_btn:addClickFuntion(self, self.onUpStarBtnClick);
    
    self:addLuaEvent("UPDATE_HERO_TAB_REDDOT", self, self.updateCostOrRed);--更新升级红点
    self:addLuaEvent("UPDATA_SELECT_COST_HERO_NUM", self, self.updateSelectCostHeroNum);--选择材料后更新数量
end

function Lua_HeroUpStarPanel:updateHeroPanelInfo(data)
    self.data = data;
    DataCenter.heroUpStarData:initUpStarData(self.data.unique_id);

    self.add_des:setLangValue(126211);
    self.add_vaule.text = self.data.heroUpStarVo.next_des;
    self.heroUpStarVo = self.data.heroUpStarVo;
    if self.heroUpStarVo.isMaxLevelLimit then
        self.limitObj:SetActive(false);
        LuaUtil.setObjPos(self.attrObj,146,0,0);
    else
        self.limitObj:SetActive(true);
        LuaUtil.setObjPos(self.attrObj,0,0,0);
        self.limit_lvl.text = self.heroUpStarVo.next_lvl_limit;
    end
    

    if self.data.heroUpStarVo.need_resonance ~= 0 then--展示同调器条件
        self.tree_des:setEnable(true);
        local str;
        local lvl = DataCenter.lifeTreeData.cur_level;--共鸣等级
        if self.data.heroUpStarVo.isMeetUpStarResonance == true then--满足共鸣条件
            str = Lua_ColorDefine.getColorStr("16A803",lvl);
        else
            str = Lua_ColorDefine.getColorStr("DE4A16",lvl);
        end
        self.tree_des.text = LanUtil.formateStr(126212,str, self.data.heroUpStarVo.need_resonance)
    else
        self.tree_des:setEnable(false);
    end
    self.redDotState = DataCenter.heroUpStarData:checkUpStarRedDot(self.data);
    self:showRedDot(self.redDotState); -- 升星红点
    self:showLeftStarsItem(self.data);
    self:showRightStarsItem(self.data);
    self:showCostHeroItem(self.heroUpStarVo);
    self:showCostMaterialItem(self.heroUpStarVo);
end

function Lua_HeroUpStarPanel:updateSelectCostHeroNum(costMaterialsIndex)
    if self.costHeroArr[costMaterialsIndex] ~= nil then
        self.costHeroArr[costMaterialsIndex]:setSelectNum();
    end
end

function Lua_HeroUpStarPanel:updateCostOrRed()
    local redDotState = DataCenter.heroUpStarData:checkUpStarRedDot(self.data);
    self:showRedDot(redDotState); -- 升星红点
    local len = self.costHeroArr:getSize();
    for i = 1, len do
        self.costHeroArr[i]:updateRedDotState(redDotState);
    end
end

function Lua_HeroUpStarPanel:showLeftStarsItem(data) -- 显示星
    if data ~= nil and data.star <10 then
        if self.leftStars == nil then
            self.leftStars = Array();
        end
        local showStar = DataCenter.heroUtil:getShowStar(data.star);
        local len = self.leftStars:getSize();
        local spr = DataCenter.heroUtil:getStarSprite(data.star, 2);
        local starWidth = 37;
        local num = len;
        if len < showStar then
            num = showStar;
        end
        for i = 1, num do
            local item = self.leftStars[i];
            if item == nil then
                item = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_label_06", 0, 0, 36, 35);
                self.leftStars:add(item);
            else
                item:setEnable(i <= showStar);
            end  
            item:setLocation(-1 * starWidth * showStar / 2 + starWidth * (i-1) + starWidth / 2 -175, -264, 0);
            item:setAltas("common_altas_1", spr);
        end
        self.left_star_bg:setEnable(false);
        self.left_star_level:setEnable(false);
    else
        if self.leftStars ~= nil then
            local len = self.leftStars:getSize();
            for i = 1, len do
                self.leftStars[i]:setEnable(false);
            end
        end
        if data == nil then
            self.star_bg:setEnable(false);
            self.left_star_level:setEnable(false);
        elseif data.star >= 10 then
            self.left_star_bg:setEnable(true);
            self.left_star_level:setEnable(data.showStar > 0);
            self.left_star_level.text = data.showStar;
        end
    end
end

function Lua_HeroUpStarPanel:showRightStarsItem(data) -- 显示星
    local showStar = DataCenter.heroUtil:getShowStar(data.star+1);
    if data ~= nil and data.star+1 <10 then
        if self.rightStars == nil then
            self.rightStars = Array();
        end
        local len = self.rightStars:getSize();
        local spr = DataCenter.heroUtil:getStarSprite(data.star+1, 2);
        local starWidth = 37;
        local num = len;
        if len < showStar then
            num = showStar;
        end
        for i = 1, num do
            local item = self.rightStars[i];
            if item == nil then
                item = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_label_06", 0, 0, 36, 35);
                self.rightStars:add(item);
            else
                item:setEnable(i <= showStar);
            end  
            item:setLocation(-1 * starWidth * showStar / 2 + starWidth * (i-1) + starWidth / 2 +187.5, -264, 0);
            item:setAltas("common_altas_1", spr);
        end
        self.right_star_bg:setEnable(false);
        self.right_star_level:setEnable(false);
    else
        if self.rightStars ~= nil then
            local len = self.rightStars:getSize();
            for i = 1, len do
                self.rightStars[i]:setEnable(false);
            end
        end
        if data == nil then
            self.star_bg:setEnable(false);
            self.right_star_level:setEnable(false);
        elseif data.star+1 >= 10 then
            self.right_star_bg:setEnable(true);
            self.right_star_level:setEnable(showStar > 0);
            self.right_star_level.text = showStar;
        end
    end
end


-- 升星英雄消耗
function Lua_HeroUpStarPanel:showCostHeroItem(heroUpStarVo)
    if heroUpStarVo ~= nil then
        local arr = heroUpStarVo.costHeroInfo;
        if self.costHeroArr == nil then
            self.costHeroArr = Array();
        end
        local len = self.costHeroArr:getSize();
        for i = 1, len do
            self.costHeroArr[i]:setEnable(false);
        end
        for i = 1, arr:getSize() do
            local item = nil;
            if self.costHeroArr[i] ~= nil then
                item = self.costHeroArr[i];
            else
                item = Lua_HeroUpStarCostItem.new(self.content);
                self.costHeroArr:add(item);
            end
            --需要自动选择材料的需要筛选一次数据
            if arr[i].isAutoSelect == true then
                arr[i]:initialCostInfo();
            end
            item:setData(arr[i]);
            item:updateRedDotState(self.redDotState);
            item:setLocation(-265+(i-1)*127, -507);
            item:setEnable(true);
        end
    else
        if self.costHeroArr ~= nil then
            local len = self.costHeroArr:getSize();
            for i = 1, len do
                self.costHeroArr[i]:setEnable(false);
            end
        end
    end
end

-- 升星材料消耗
function Lua_HeroUpStarPanel:showCostMaterialItem(heroUpStarVo)
    if heroUpStarVo ~= nil then
        local arr = heroUpStarVo.costMaterialInfo;
        if self.costMaterialArr == nil then
            self.costMaterialArr = Array();
        end
        local len = self.costMaterialArr:getSize();
        for i = 1, len do
            self.costMaterialArr[i]:setEnable(false);
        end
        for i = 1, arr:getSize() do
            local item = nil;
            if self.costMaterialArr[i] ~= nil then
                item = self.costMaterialArr[i];
            else
                item = Lua_HeroCostItem.new(self.content);
                self.costMaterialArr:add(item);
            end
            item:setData(arr[i]);
            item:setLocation(115+(i-1)*127, -450, 0);
            item:setEnable(true);
        end
    else
        if self.costMaterialArr ~= nil then
            local len = self.costMaterialArr:getSize();
            for i = 1, len do
                self.costMaterialArr[i]:setEnable(false);
            end
        end
    end
end

function Lua_HeroUpStarPanel:onUpStarBtnClick() -- 升星
    if self.clickTime ~= nil and (getTime() - self.clickTime) < 0.5 then
        return;
    end
    
    self.clickTime = getTime();
    if self.data.heroUpStarVo.isMeetUpStarResonance == false then
        OperateAlert.showLangValue(126213);
        return;
    end

    local isMeetUpStarCost = self.heroUpStarVo.isMeetUpStarCost;
    if isMeetUpStarCost ~= true then
        DataCenter.packUtil:openPathWindow(isMeetUpStarCost, false);
        return;
    end

    if DataCenter.heroUpStarData:isUpStar(self.heroUpStarVo.all_num) == true then
        if self.data.star >= DataCenter.heroUtil.rollback_high then
            local str = LanUtil.formateStr(126216,tostring(self.data.star+1));
            local tipsData = { des = str, btnType = 1, owner = self, sureFun = self.sureBtnClick };
            Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
        else
            self:sureBtnClick();
        end
    else
        OperateAlert.showLangValue(126210);
    end
end

function Lua_HeroUpStarPanel:sureBtnClick()
    Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroUpStar(self.data.unique_id);
end

--升星红点
function Lua_HeroUpStarPanel:showRedDot(val)
    if val == true then
        if self.redDotIcon == nil then
            self.redDotIcon = Lua_RedPointIcon.new(self.content);
            self.redDotIcon:setLocation(295, -505, 0);
            self.redDotIcon:createRedPointImg(nil);
        end
        self.redDotIcon:updateRedPointShow(true);
    else
        if self.redDotIcon ~= nil then
            self.redDotIcon:updateRedPointShow(false);
        end
    end
end

function Lua_HeroUpStarPanel:dispose()
    if self.leftStars ~= nil then
        self.leftStars:dispose();
        self.leftStars:clear();
        self.leftStars = nil;
    end

    if self.rightStars ~= nil then
        self.rightStars:dispose();
        self.rightStars:clear();
        self.rightStars = nil;
    end

    if self.costHeroArr ~= nil then
        self.costHeroArr:dispose();
        self.costHeroArr:clear();
        self.costHeroArr = nil;
    end
    if self.costMaterialArr ~= nil then
        self.costMaterialArr:dispose();
        self.costMaterialArr:clear();
        self.costMaterialArr = nil;
    end

    if self.redDotIcon ~= nil then
        self.redDotIcon:dispose();
        self.redDotIcon = nil;
    end
    DataCenter.heroUpStarData:clean();
    self.data = nil;
    self:superCall("dispose");
end