-- 英雄升星成功Tips
checkRequire("Lua_HeroBreakAttributeItem");
Lua_HeroUpStarSucceedWindow = class("Lua_HeroUpStarSucceedWindow", Lua_Window);
function Lua_HeroUpStarSucceedWindow:ctor()
    self:superCall("ctor");
    self.isClickClose = true;
    self.showBlackMask = true;
    self.showCloseText = true;
    self.closeTextPosY = -445;
    self.windowName = "Lua_HeroUpStarSucceedWindow";
    self.skinName = "HeroUpStarSucceedWindow_skin";
end

function Lua_HeroUpStarSucceedWindow:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_HeroUpStarSucceedWindow:showWin(param)
    if param.data.heroUpStarVo.isMaxLevelLimit then
        self.limit_des:setEnable(false);
    else
        local str = DataCenter.heroUtil:getHeroStarConfigInfo(param.data.star).add_lvl_limit;
        self.limit_des.text =  LanUtil.formateStr(126214,tostring(str));
        self.limit_des:setEnable(true);
    end
    self:showLeftStarsItem(param.data);
    self:showRightStarsItem(param.data);
    self:showAttributes(param.data,param.attrDic);
end

-- 属性展示
function Lua_HeroUpStarSucceedWindow:showAttributes(data, prop_list)
    local info = DataCenter.heroData:showAttrInfo(data, prop_list);
    if info ~= nil then
        if self.attrInfo == nil then
            self.attrInfo = Array();
        end
        local len = self.attrInfo:getSize();
        for i = 1, len do
            self.attrInfo[i]:setEnable(false);
        end
        for i = 1, info:getSize() do
            local item = nil;
            if self.attrInfo[i] ~= nil then
                item = self.attrInfo[i];
            else
                item = Lua_HeroBreakAttributeItem.new(self.content);
                self.attrInfo:add(item);
            end
            item:setIndex(i);
            item:setData(info[i]);
            item:setLocation(0,207 - (i-1)*46, 0);
            item:setEnable(true);
        end
    else
        if self.attrInfo ~= nil then
            local len = self.attrInfo:getSize();
            for i = 1, len do
                self.attrInfo[i]:setEnable(false);
            end
        end
    end
end

function Lua_HeroUpStarSucceedWindow:showLeftStarsItem(data) -- 显示星
    if data ~= nil and data.star-1 < 10 then
        if self.leftStars == nil then
            self.leftStars = Array();
        end
        local showStar = DataCenter.heroUtil:getShowStar(data.star-1);
        local len = self.leftStars:getSize();
        local spr = DataCenter.heroUtil:getStarSprite(data.star-1, 3);
        local starWidth = 26;
        local num = len;
        if len < showStar then
            num = showStar;
        end
        for i = 1, num do
            local item = self.leftStars[i];
            if item == nil then
                item = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 26, 27);
                self.leftStars:add(item);
            else
                item:setEnable(i <= showStar);
            end  
            item:setLocation(-1 * starWidth * showStar / 2 + starWidth * (i-1) + starWidth / 2 -162, 268, 0);
            item:setAltas("common_altas_1", spr);
        end
        self.left_star_bg:setEnable(false);
        self.left_star_level:setEnable(false);
    else
        if self.leftStars ~= nil then
            local len = self.leftStars:getSize();
            for i = 1, len do
                self.leftStars[i]:setEnable(false);
            end
        end
        if data == nil then
            self.star_bg:setEnable(false);
            self.left_star_level:setEnable(false);
        elseif data.star >= 10 then
            self.left_star_bg:setEnable(true);
            self.left_star_level:setEnable(data.star-1 > 10);
            self.left_star_level.text = data.showStar - 1;
        end
    end
end

function Lua_HeroUpStarSucceedWindow:showRightStarsItem(data) -- 显示星
    if data ~= nil and data.star < 10 then
        if self.rightStars == nil then
            self.rightStars = Array();
        end
        local len = self.rightStars:getSize();
        local spr = DataCenter.heroUtil:getStarSprite(data.star, 3);
        local starWidth = 26;
        local num = len;
        if len < data.showStar then
            num = data.showStar;
        end
        for i = 1, num do
            local item = self.rightStars[i];
            if item == nil then
                item = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0,  26, 27);
                self.rightStars:add(item);
            else
                item:setEnable(i <= data.showStar);
            end  
            item:setLocation(-1 * starWidth * data.showStar / 2 + starWidth * (i-1) + starWidth / 2 + 162, 268, 0);
            item:setAltas("common_altas_1", spr);
        end
        self.right_star_bg:setEnable(false);
        self.right_star_level:setEnable(false);
    else
        if self.rightStars ~= nil then
            local len = self.rightStars:getSize();
            for i = 1, len do
                self.rightStars[i]:setEnable(false);
            end
        end
        if data == nil then
            self.star_bg:setEnable(false);
            self.right_star_level:setEnable(false);
        elseif data.star >= 10 then
            self.right_star_bg:setEnable(true);
            self.right_star_level:setEnable(data.star > 10);
            self.right_star_level.text = data.showStar;
        end
    end
end
function Lua_HeroUpStarSucceedWindow:dispose()
    if self.leftStars ~= nil then
        self.leftStars:dispose();
        self.leftStars:clear();
        self.leftStars = nil;
    end

    if self.rightStars ~= nil then
        self.rightStars:dispose();
        self.rightStars:clear();
        self.rightStars = nil;
    end

    if self.attrInfo ~= nil then
        self.attrInfo:dispose();
        self.attrInfo:clear();
        self.attrInfo = nil;
    end
    
    self.data = nil;
    self:superCall("dispose");
end