-- 英雄神兵
checkRequire("Lua_HeroMaterialItem")
Lua_HeroWeaponPanel = class("Lua_HeroWeaponPanel", Lua_DisplayObject);
function Lua_HeroWeaponPanel:ctor(p)
	self:superCall("ctor", p, "HeroWeaponPanel_skin");
end

function Lua_HeroWeaponPanel:buildShowItem()
	self:superCall("buildShowItem");
	self.skillItem = Lua_SkillIconItem.new(self.content)
	self.skillItem:setLocation(295, -400, 0)
	self.skillItem:setCanClick(true, self, self.onSkillClick)

	self.checkHelp:addClickFuntion(self, self.onCheckHelp)
	self.btnFunc:addClickFuntion(self, self.onBtnFuncClick)

	self:addLuaEvent("UPDATE_HERI_MATERIAL_SELECT", self, self.updateCostHero)
end

function Lua_HeroWeaponPanel:dispose()
	if self.skillItem then
		self.skillItem:dispose()
		self.skillItem = nil
	end
	if self.attrArr then
		self.attrArr:dispose()
		self.attrArr:clear()
		self.attrArr = nil
	end
	if self.costArr then
		self.costArr:dispose()
		self.costArr:clear()
		self.costArr = nil
	end
	if self.costHeroArr then
		self.costHeroArr:dispose()
		self.costHeroArr:clear()
		self.costHeroArr = nil
	end
	if self.redPointIcon then
		self.redPointIcon:dispose()
		self.redPointIcon = nil
	end
	DataCenter.heroMaterialData:dispose()
	self.data = nil
	self.weaponCfg = nil
	self:superCall("dispose")
end

function Lua_HeroWeaponPanel:updateHeroPanelInfo(data)
	self.data = data

	local attrArr
	if data.weapon_id > 0 then -- 已解锁
		self.weaponCfg = DataCenter.heroUtil:getWeaponConfig(data.weapon_id)
		self.unlockText:setEnable(false)
		self.levelObject:SetActive(true)
		if self.weaponCfg.next_id and self.weaponCfg.next_id > 0 then
			local nextCfg = DataCenter.heroUtil:getWeaponConfig(self.weaponCfg.next_id)
			attrArr = DataCenter.attributesUtil:getAttrArrByDic(self.weaponCfg.prop, nextCfg.prop)
			self.arrow:setEnable(true)
			self.nextLevel:setEnable(true)
			self.btnFunc:setMouseEnable(true)
			self.btnFunc.label = "升 级"
			self:showConsume(self.weaponCfg.material)
			self:showHeroConsume(self.weaponCfg.hero_material)
			self:showRedPoint()
		else
			attrArr = DataCenter.attributesUtil:getAttrArrByDic(self.weaponCfg.prop)
			self.arrow:setEnable(false)
			self.nextLevel:setEnable(false)
			self.btnFunc:setMouseEnable(false)
			self.btnFunc.label = "已满级"
			self:showConsume(nil)
			self:showHeroConsume(nil)
			self:showRedPoint(false)
		end
		self.skillItem:setLock(false)
	else
		self.weaponCfg = DataCenter.heroUtil:getWeaponConfig(data.weaponId)
		attrArr = DataCenter.attributesUtil:getAttrArrByDic(self.weaponCfg.prop)
		self.unlockText:setEnable(true)
		self.levelObject:SetActive(false)
		self.btnFunc:setMouseEnable(true)
		self.btnFunc.label = "解 锁"
		self.skillItem:setLock(true)
		self:showConsume(self.weaponCfg.unlock_material)
		self:showHeroConsume(nil)
		self:showRedPoint()
	end
	self.nameText.text = self.weaponCfg.name
	self.curLevel.text = self.weaponCfg.level
	self.nextLevel.text = self.weaponCfg.level + 1
	self.skillItem:setSkillId(self.weaponCfg.skill[1])
	self:showAttributes(attrArr)
end

function Lua_HeroWeaponPanel:updateCostHero(index)
	if self.costHeroArr[index] then
		self.costHeroArr[index]:updateNum()
	end
end

function Lua_HeroWeaponPanel:showAttributes(arr)
	if self.attrArr == nil then
		self.attrArr = Array()
	end
	local len = self.attrArr:getSize()
	local dataLen = arr:getSize()
	local maxLen = dataLen > len and dataLen or len
	local item
	for i = 1, maxLen do
		item = self.attrArr[i]
		if i > dataLen then
			if item then
				item:setEnable(false)
			end
		else
			if item == nil then
				item = Lua_HeroWeaponAttrItem.new(self.content)
				self.attrArr:add(item)
			else
				item:setEnable(true)
			end
			item:setLocation(-35, -330 - (i - 1) * 50, 0)
			item:setData(arr[i])
		end
	end
end

function Lua_HeroWeaponPanel:showConsume(data)
	if self.costArr == nil then
		self.costArr = Array();
	end

	local len = self.costArr:getSize();
	if data == nil then
		len = -len;
	else
		len = #data - len;
	end
	while (len > 0) do
		item = Lua_ConsumeIconItem.new(self.content);
		item:setStyle(Lua_MyUISettings.defaultFontName, 22, "FFFFFF", 2, "2B3136", 2, 2);
		item:setColorStr("2FC548", "FB524B");
		self.costArr:add(item);
		len = len - 1;
	end

	while (len < 0) do
		item = self.costArr:remove(1);
		item:dispose();
		len = len + 1;
	end

	len = self.costArr:getSize();
	local space = 300;
	local w = -(space * len) / 2 + space / 2;
	local posX;
	for i = 1, len do
		item = self.costArr[i];
		item:setData(data[i]);

		posX = ((i - 1) % len) * space + w;
		item:setLocation(posX, -510, 0);
	end
end

function Lua_HeroWeaponPanel:showHeroConsume(data)
	if self.costHeroArr == nil then
		self.costHeroArr = Array()
	end

	local len = self.costHeroArr:getSize()
	local dataLen = 0
	if data then
		dataLen = #data
		DataCenter.heroMaterialData:init(self.data.unique_id)
	else
		DataCenter.heroMaterialData:dispose()
	end

	local maxLen = dataLen > len and dataLen or len
	local item
	local space = 120
	local w = -(space * dataLen) / 2 + space / 2
	local vo
	local arr
	for i = 1, maxLen do
		item = self.costHeroArr[i]
		if i > dataLen then
			if item then
				item:setEnable(false)
			end
		else
			if item then
				item:setEnable(true)
			else
				item = Lua_HeroMaterialItem.new(self.content)
				self.costHeroArr:add(item)
			end
			item:setLocation(-210 + ((i - 1) % dataLen) * space + w, -475, 0)

			vo = Lua_HeroMaterialVo.new(i)
			vo:setData(data[i])
			item:setData(vo)

			arr = DataCenter.heroMaterialData:getHeroList(vo)
			if arr and arr:getSize() > 0 then
				DataCenter.heroMaterialData:addHero(vo.index, arr[1])
			end
			item:updateNum()
		end
	end
end

function Lua_HeroWeaponPanel:showRedPoint(bState)
	if bState == nil then
		if self.data.weapon_id > 0 then
			local costId, costCount = DataCenter.packData:checkConsumeEnough(self.weaponCfg.material)
			if costId then
				bState = false
			else
				if DataCenter.heroMaterialData:checkEnough(self.weaponCfg.hero_material) then
					bState = true
				else
					bState = false
				end
			end
		else
			local costId, costCount = DataCenter.packData:checkConsumeEnough(self.weaponCfg.unlock_material)
			if costId then
				bState = false
			else
				bState = true
			end
		end		
	end

	if bState == true then
		if self.redPointIcon == nil then
			self.redPointIcon = Lua_RedPointIcon.new(self.content)
			self.redPointIcon:setLocation(75, -545)
			self.redPointIcon:createRedPointEff()
		end
		self.redPointIcon:updateRedPointShow(true)
	else
		if self.redPointIcon then
			self.redPointIcon:updateRedPointShow(false)
		end
	end
end

function Lua_HeroWeaponPanel:onSkillClick(data)
	if self.data == nil then
		return;
	end
	Lua_WindowUtil.openWin("Lua_HeroWeaponSkillWindow", Lua_WinParam.ACTION_OPEN, self.data);
end

function Lua_HeroWeaponPanel:onCheckHelp(go)
	local tipsData = { posX = 200, posY = 335, des = LanUtil.getValue(390000), isBottomShow = true }
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData)
end

function Lua_HeroWeaponPanel:onBtnFuncClick(go)
	if self.data.weapon_id > 0 then
		local costId, costCount = DataCenter.packData:checkConsumeEnough(self.weaponCfg.material)
		if costId then
			DataCenter.packUtil:openPathWindow(costId, false)
		else
			if DataCenter.heroMaterialData:checkEnough(self.weaponCfg.hero_material) then
				Lua_ProxyManager.getProxy("Lua_HeroProxy"):sUpgradeWeapon(self.data.unique_id, DataCenter.heroMaterialData.uniqueIdDic)
			else
				OperateAlert.show("所需英雄材料不足")
			end
		end
	else
		local costId, costCount = DataCenter.packData:checkConsumeEnough(self.weaponCfg.unlock_material)
		if costId then
			DataCenter.packUtil:openPathWindow(costId, false)
		else
			Lua_ProxyManager.getProxy("Lua_HeroProxy"):sUnlockWeapon(self.data.unique_id)
		end
	end
end




















Lua_HeroWeaponAttrItem = class("Lua_HeroWeaponAttrItem", Lua_DisplayObject);
function Lua_HeroWeaponAttrItem:ctor(p)
	self:superCall("ctor", p, "HeroWeaponAttrItem_skin");
end

function Lua_HeroWeaponAttrItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_HeroWeaponAttrItem:dispose()
	self:superCall("dispose");
end

function Lua_HeroWeaponAttrItem:setData(data)
	self.attrIcon:setAltas("common_altas_2", data.hero_attr_icon)
	self.nameText.text = data.show_name
	self.curText.text = data.showValue
	if data.nextValue and data.nextValue > 0 then
		self.arrow:setEnable(true)
		self.nextText:setEnable(true)
		self.nextText.text = data.showNextValue
	else
		self.arrow:setEnable(false)
		self.nextText:setEnable(false)
	end
end