Lua_HeroWeaponSkillWindow = class("Lua_HeroWeaponSkillWindow", Lua_Window);
function Lua_HeroWeaponSkillWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_HeroWeaponSkillWindow";
	self.skinName = "HeroWeaponSkillWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_HeroWeaponSkillWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.tipsContainer = Lua_DragContainer.new(self.content, 650, 275, Lua_AxisDefine.Vertical)
	self.tipsContainer:setLocation(0, -150, 0)
	self.tipsContainer:setCellSpacing(0, 10)
end

function Lua_HeroWeaponSkillWindow:dispose()
	if self.tipsContainer then
		self.tipsContainer:dispose()
		self.tipsContainer = nil
	end
	self:superCall("dispose")
end

function Lua_HeroWeaponSkillWindow:showWin(param)
	self:superCall("showWin", param)
	self.heroName.text = param.name

	local data
	if param.weapon_id > 0 then -- 已解锁
		data = DataCenter.heroUtil:getWeaponConfig(param.weapon_id)
	else
		data = DataCenter.heroUtil:getWeaponConfig(param.weaponId)
	end

	local arr = Array()
	local level = 0
	local config
	while true do
		config = DataCenter.heroUtil:getWeaponConfig(param.weaponId + level)
		if config.show_tips == 1 then
			arr:add({ skillId = config.skill[1], level = config.level, bActivate = param.weapon_id > 0 and config.level <= data.level })
		end
		level = level + 1
		if config.next_id == nil or config.next_id <= 0 then
			break
		end
	end

	self.nameText.text = data.name
	self.desText.text = data.des
	if param.weapon_id > 0 then
		self.levelText.text = data.level
		self.attrText.text = DataCenter.attributesUtil:getAttrStr(data.prop)
	else
		self.levelText.text = level
		self.attrText.text = DataCenter.attributesUtil:getAttrStr(config.prop)
	end

	for i = 1, arr:getSize() do
	    self.tipsContainer:addSubContainer(Lua_HeroWeaponSkillItem, arr[i])
	end
	self.tipsContainer:updateChildPos()
	self.tipsContainer.canDrag = not self.tipsContainer.bDragEnd
end





















Lua_HeroWeaponSkillItem = class("Lua_HeroWeaponSkillItem", Lua_DragContainerItem);
function Lua_HeroWeaponSkillItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_HeroWeaponSkillItem:buildShowItem()
    self:superCall("buildShowItem");

    self.tipsText = UICreate.createLabel(self.content, nil, 0, 0, 650, 0, 20);
    self.tipsText.verticalOverflowValue = 1;
end

function Lua_HeroWeaponSkillItem:dispose()
    self:superCall("dispose");
end

function Lua_HeroWeaponSkillItem:getWidth()
    return self.tipsText.width;
end

function Lua_HeroWeaponSkillItem:getHeight()
    return self.tipsText.height;
end

function Lua_HeroWeaponSkillItem:setData(data)
	local config = Lua_SkillConfigData.getConfigData(data.skillId)
	local str
	if data.level == 1 then
		str = LanUtil.formateStr("激活：{1}", config.des)
	else
		str = LanUtil.formateStr("强化至+{1}：{2}", tostring(data.level), config.des)
	end
	if data.bActivate then
		str = Lua_ColorDefine.getColorStr("459252", str)
	end
    self.tipsText.text = str
    self.tipsText:resetSize()
end