-- 英雄Panel
checkRequire("Lua_HeroCellsItem"); -- cell
Lua_HeroPanel = class("Lua_HeroPanel", Lua_DisplayObject);
function Lua_HeroPanel:ctor(p)
    self:superCall("ctor", p,"HeroPanel_skin");
end

function Lua_HeroPanel:addEvent()
    self:addLuaEvent("ADD_HERO_ITEM", self, self.updatePackSizeInfo);--英雄增加
    self:addLuaEvent("DELETE_HERO_ITEM", self, self.updatePackSizeInfo);--英雄删除
    self:addLuaEvent("UPDATE_ADD_BAG_SIZE", self, self.updatePackSizeInfo);--背包数量更新
    self:addLuaEvent("SELECT_SHOW_ATTRS_WINOW_INDEX", self, self.onOpenAttrWinow); -- 打开属性面板
    self:addLuaEvent("ENFORCE_UPDATA_HERO_PANEL", self, self.enforceUpdateHeroInfo); -- 在属性界面强制刷新
    self:addLuaEvent("GUIDE_SELECTED_HERO", self, self.guideSelectedHero); -- 引导查找英雄item
    self.add_btn:addClickFuntion(self, self.onAddBtnClick);
end

function Lua_HeroPanel:buildShowItem()
    self:superCall("buildShowItem");
    self:addEvent();

    local siftAllInfo = DataCenter.heroUtil.siftAllInfo;
    self.siftPosXs = Array();
    self.siftArr = Array();
    self.siftSpace = 82;
    local len = siftAllInfo:getSize();
    local item;
    local w;
    local posX;
    for i = 1, len do
        item = Lua_CampSiftBaseItem.new(self.content, self.siftSpace);
        item:setRectAnchor(7);
        w = -(self.siftSpace * len) / 2 + self.siftSpace / 2;
        posX = ((i - 1) % len) * self.siftSpace + w;
        item:setLocation(posX, 290, 0);

        item:setData(siftAllInfo[i]);
        item:setClickCallBack(self, self.updateHeroSiftInfo);

        self.siftPosXs:add(posX);
        self.siftArr:add(item);
    end

    self.dragList = Lua_DragList.new(self.content,702, 928+self.adaptHeight, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_HeroCellsItem, 172, 248, 4);
    self.dragList:setSubOffect(5, 0);
    self.dragList:setCellSpacing(4, 7);
    self.dragList:setLocation(0, 82);

    self:updatePackSizeInfo();
    self:updateHeroSiftInfo(Lua_HeroUtil.All_TYPE);
end

-- 强制刷新
function Lua_HeroPanel:enforceUpdateHeroInfo()
    DataCenter.heroData:sortHeroInfo();
    self:updateDragInfo(self.selectSiftType);
end

function Lua_HeroPanel:updatePackSizeInfo()
    self.add_btn:setEnable( not DataCenter.heroData.isExtendBagLimit);
    local arr = DataCenter.heroData.allHeroUidArr;
    local left_num = Lua_ColorDefine.getColorStr("eaebed",arr:getSize());
    local right_num = Lua_ColorDefine.getColorStr("b8c5c3","/"..DataCenter.heroData.bag_size);
    self.show_num.text = left_num..right_num;
end

function Lua_HeroPanel:updateShow()
    self.selectSiftType = nil;
    self:updateHeroSiftInfo(Lua_HeroUtil.All_TYPE);
end
    
function Lua_HeroPanel:updateHeroSiftInfo(selectType) -- 更新筛选状态
    if self.selectSiftType == selectType then
        return;
    end
    self.selectSiftType = selectType;
    
    local posX;
    local item;
    for i = 1, self.siftArr:getSize() do
        posX = self.siftPosXs[i];
        item = self.siftArr[i];
        if item.data.type > selectType then -- 往右移
            item:setLocation(posX + self.siftSpace / 2, item.y, 0);
        else -- 往左移
            item:setLocation(posX - self.siftSpace / 2, item.y, 0);
        end

        if item.data.type == selectType then
            item:setSelectEnable(true);
        else
            item:setSelectEnable(false);
        end
    end
    
    self:updateDragInfo(selectType)
end

-- 打开属性面板
function Lua_HeroPanel:updateDragInfo(selectType)
    TweenUtil.getInstance():stop(self.dragList.content);
    self.showCampTypeArr = DataCenter.heroData:getPackAllInfoByCampType(selectType);
    self.dragList:setArrayData(self.showCampTypeArr);
    self.dragList:moveToIndex(1, true);
    TweenUtil.getInstance():addTweenTargetAlpha(self.dragList.content, 0.5, 0, -1, true);
end

-- 打开属性面板
function Lua_HeroPanel:onOpenAttrWinow(data)
    if data == nil then
        return;
    end 

    local info = {arr = self.showCampTypeArr, selectSiftType = self.selectSiftType, selectBtn = 1, unique_id = data.unique_id, createIdx = data.index};
    -- print("选择索引 = = ",data.index);
    local unique_id = self.showCampTypeArr[data.index].unique_id;
    local heroVo = DataCenter.heroData:getItemByUniqueId(unique_id);
    DataCenter.preLoadData:preShowModelScene("Lua_HeroShowAttributeWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onShowModel, info, heroVo);
end

function Lua_HeroPanel:onShowModel(param, modelScenePanel)
    param.modelScenePanel = modelScenePanel;
    Lua_WindowUtil.openWin("Lua_HeroShowAttributeWindow", Lua_WinParam.ACTION_OPEN, param);
end

function Lua_HeroPanel:onAddBtnClick()
    local vo = DataCenter.heroUtil:getBagCostVoById(DataCenter.heroData.extend_times+1);
    if vo ~= nil and vo.amount ~= nil then
        local str = spliceIconStrById(Lua_ResourcesDefine.DIAMOND);
        local tipData = {
            des = LanUtil.formateStr(126110, str, tostring(vo.amount), tostring(vo.add)),
            posY = 50, btnType = 1, owner = self, sureFun = self.onSubBtnClick

        };
        Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
    else
        self:onSubBtnClick() -- 确定
    end
end

function Lua_HeroPanel:onSubBtnClick() -- 确定
    Lua_ProxyManager.getProxy("Lua_HeroProxy"):sAddPackSize(); --请求英雄数据
end

function Lua_HeroPanel:onScreenResize(adaptHeight)
    if self.adaptHeight ~= adaptHeight then
        self.dragList:setContentRect(702, 928 + adaptHeight);
    end
end

function Lua_HeroPanel:dispose()
    if self.siftArr ~= nil then
        self.siftArr:dispose();
        self.siftArr:clear();
        self.siftArr = nil;
    end
    if self.siftPosXs ~= nil then
        self.siftPosXs:clear();
        self.siftPosXs = nil;
    end

    if self.dragList ~= nil then
        TweenUtil.getInstance():stop(self.dragList.content);
        self.dragList:dispose();
        self.dragList = nil;
    end
    
    if self.fetterRedDot then
        self.fetterRedDot:dispose();
        self.fetterRedDot = nil;
    end

    self.showCampTypeArr = nil;
    DataCenter.preLoadData:removeBySign("Lua_HeroShowAttributeWindow", self, self.onShowModel);
    self:superCall("dispose");
end

function Lua_HeroPanel:guideSelectedHero(heroId)
    if heroId ~= nil then
        local unique_id;
        local maxLvl = 0;
        local arr = DataCenter.heroData:getHeroUidArrById(heroId);
        if arr:getSize() == 0 then
            return;
        end
        for i = 1, arr:getSize() do
            local heroVo = DataCenter.heroData:getItemByUniqueId(arr[i]);
            if heroVo ~= nil and heroVo.level > maxLvl then
                unique_id = arr[i];
                maxLvl = heroVo.level;
            end
        end
        
        arr = self.dragList.showDragDataList;
        local index = 1;
        for i = 1, arr:getSize() do
            local cellData = arr:getItem(i).data;
            if cellData.unique_id == unique_id then
                index = i;
                self.dragList:moveToIndex(index, true);
                break;
            end
        end

        local item = self.dragList.showDragDataList:getItem(index).cell;
        local path = "content/Lua_HeroPanel/Lua_DragList/ScrollContainer/Content/"..item.content.name;
        Lua_MsgUtil.callFunc("GUIDE_SELECT_HERO_TARGETITEM", path);
    end
end