--英雄属性展示
checkRequire("Lua_HeroTabCell");
checkRequire("Lua_HeroShowBaseWindow");
Lua_HeroShowAttributeWindow = class("Lua_HeroShowAttributeWindow", Lua_HeroShowBaseWindow);
function Lua_HeroShowAttributeWindow:ctor()
    self:superCall("ctor");
    self.windowName = "Lua_HeroShowAttributeWindow";
    self.selectIndex = 1; --英雄选择索引
end

function Lua_HeroShowAttributeWindow:addEvent()
    self:addLuaEvent("ADD_HERO_ITEM", self, self.updateShowArr);-- 英雄增加
    self:addLuaEvent("DELETE_HERO_ITEM", self, self.updateShowArr);-- 英雄删除

    self:addLuaEvent("UPDATE_ONE_HERO_INFO", self, self.updateShowHero);-- 数据更新
    self:addLuaEvent("UPDATA_TAG_BUTTON_ITEM", self, self.onTabBtnClick);-- 页签按钮
    
    self:addLuaEvent("UPDATE_HERO_TAB_REDDOT", self, self.updateShowTabBtnState);--页签红点更新
end

function Lua_HeroShowAttributeWindow:buildShowItem()
    self:superCall("buildShowItem");
    self:addEvent();
    self.type_icon:setScale(0.85, 0.85, 1);
    self.type_icon:setLocation(-122, -42, 0);
    self.tag_update = false;--更新标记
    self.sub_btn:setEnable(false);
    self.add_btn:setEnable(false);

    self.tabList = Lua_DragList.new(self.downObj, 472, 108, Lua_AxisDefine.Horizontal);
    self.tabList:setListCell(Lua_HeroTabCell, 118, 108, 1);
    self.tabList:setRectPivot(5);
    self.tabList:setLocation(358, 54);
    
    self.sub_btn:addClickFuntion(self, self.onSubBtnClick);
    self.add_btn:addClickFuntion(self, self.onAddBtnClick);
    self.lock_btn:addClickFuntion(self, self.onLockBtnClick);-- 上锁
    self.comment_btn:addClickFuntion(self, self.onCommentBtnClick);-- 评论
    self.rebuild_btn:addClickFuntion(self, self.onRebuildBtnClick);-- 重修
    self.introduce_btn:addClickFuntion(self, self.onIntroduceBtnClick);-- 传记
end

function Lua_HeroShowAttributeWindow:onScreenResize()
    self:superCall("onScreenResize");
    if self.modelScenePanel ~= nil then
        self.modelScenePanel:setRotBgDimensions(720,815+self.adaptHeight);
    end
    if self.curPanel ~= nil then
        self.curPanel:setRectSize(self.width, self.height);
    end
end

--英雄展示数据
function Lua_HeroShowAttributeWindow:showWin(param)
    self:superCall("showWin", param);
    if param == nil then
        self:hide();
        return;
    end
    self.curSelectIdx = nil;
    self.selectTabId = nil;
    self.selectBtn = param.selectBtn;
    self.showArr = param.arr; --英雄背包数据
    if self.showArr ~= nil then
        self.showIdx = param.createIdx;
        self.selectSiftType = param.selectSiftType;--当前选择阵容页签的类型
    else--外部打开
        if param.unique_id == nil then
            self:hide();
            return;
        end
        self.selectUId = param.unique_id;
    end
    self.isSignOpenW = true;
    self:updateShowHeroInfo();-- 显示英雄信息
end

-- 页签显示状态
function Lua_HeroShowAttributeWindow:updateShowTabBtnState(selectTabId)
    if selectTabId ~= nil then --例：Tips窗口跳转，升级页签跳转到升星页签
        self.selectTabId = nil;
    end
    if self.selectTabId ~= nil  then
        selectTabId =  self.selectTabId;
    end
    local arr,curSelectIdx = DataCenter.heroUtil:updateTabInfo(self.data, selectTabId);
    local moveToIndex = curSelectIdx;
    local len = arr:getSize();
    if len < 4 then
        self.tabList:setContentRect(118*len, 108);
    else
        self.tabList:setContentRect(472, 108);
    end
    self.tabList:setArrayData(arr);
    self.tabList:setSelected(moveToIndex);
    self.tabList:moveToIndex(moveToIndex);
    self.tabList.canDrag = len > 4;

    -- 选中页签索引发生改变标记
    if self.curSelectIdx ~= moveToIndex then 
        self.curSelectIdx = moveToIndex;
        if self.selectUId ~= nil then-- 外部打开
            self:onTabBtnClick(arr[moveToIndex]);
        else
            self:onTabBtnClick(arr[moveToIndex]);
        end
    end
end

-- 页签处理
function Lua_HeroShowAttributeWindow:onTabBtnClick(tabVo)
    if tabVo.showGrayState == true then
        OperateAlert.show(tabVo.showTipsDes);
        return;
    end
    if self.selectTabId == tabVo.id then
        return;
    end

    self.selectTabId = tabVo.id;
    self.curSelectIdx = tabVo.id;
    self.tabList:moveToIndex(self.curSelectIdx);
    self.attr_obj:SetActive(tabVo.id ~=4);

    local panelName = tabVo.panel;
    if self.panelName ~= panelName then
        if self.curPanel ~= nil then
            self.curPanel:dispose();
            self.curPanel = nil;
        end
        self.panelName = panelName;
        local showPanel = checkRequire(self.panelName);
        self.curPanel = showPanel.new(self.downObj);
    end
    self.curPanel:setLocation(0, 720, 0);
    self.curPanel:setRectSize(self.width, self.height);
    self.curPanel:updateHeroPanelInfo(self.data);
end

function Lua_HeroShowAttributeWindow:onSubBtnClick()
    if self.modelScenePanel == nil or self.modelScenePanel:checkShowComplete() ~= true then 
        return;
    end

    if self.showArr == nil then
        return;
    end

    if self.showIdx <= 1 then
        return;
    end

    self.showIdx = self.showIdx - 1;
    self.tag_update = false;
    self:updateShowHeroInfo();
end

function Lua_HeroShowAttributeWindow:onAddBtnClick()
    if self.modelScenePanel == nil or self.modelScenePanel:checkShowComplete() ~= true then 
        return;
    end

    if self.showArr == nil then
        return;
    end

    local len = self.showArr:getSize();
    if self.showIdx >= len then
        return;
    end
    
    self.showIdx = self.showIdx + 1;
    self.tag_update = false;
    self:updateShowHeroInfo();
end

--数据更新
function Lua_HeroShowAttributeWindow:updateShowHero(uid)
    if self.data.unique_id == uid then
        self.tag_update = true;
        self:updateShowHeroInfo();
    end
end

--英雄删除/增加，更新一次展示列表数据，确保左右切换页签数据的正确
function Lua_HeroShowAttributeWindow:updateShowArr()
    if self.selectUId ~= nil then --外部打开，不再更新列表数据
        return;
    end
    DataCenter.heroData:sortHeroInfo();
    self.showArr, self.showIdx = DataCenter.heroData:getPackAllInfoByCampType(self.selectSiftType, self.data.unique_id);
    self:updateTabState();
end

function Lua_HeroShowAttributeWindow:updateShowHeroInfo()
    if self.showArr == nil then
        if self.selectUId == nil then
            self:hide();
            return;
        end

        self.data = DataCenter.heroData:getItemByUniqueId(self.selectUId);
        if self.data == nil then
            self:hide();
            return;
        end

        self.sub_btn:setEnable(false);
        self.add_btn:setEnable(false);
    else
        local unique_id = self.showArr[self.showIdx].unique_id;
        self.data = DataCenter.heroData:getItemByUniqueId(unique_id);
        self:updateTabState()
    end
    
    self.name.text = self.data.name;
    self.title.text = self.data.title;
    self.forceNum.num = self.data.heroForce;
    self.profession.text = self.data.career_des;
    self.type_icon:setAltas("common_altas_2", "ui_common_icon_"..28+self.data.campType);

    if self.data.isCultivateHero then
        self.rebuild_btn:setEnable(true);
    else
        self.rebuild_btn:setEnable(false);
    end
    
    if self.data.lock_state == true then
        self.lock_btn:setAltas("common_altas_1","ui_common_button_018_n");
    else
        self.lock_btn:setAltas("common_altas_1","ui_common_button_036_n");
    end
    self:updateShowTabBtnState();  -- 更新页签显示
    self:showStarsItem(self.data); -- 显示星级
    if self.tag_update == false then
        self:showHeroMondel(self.data);-- 模型展示
    end
    -- 切换页签更新数据
    if self.curPanel ~= nil and self.isSignOpenW ~= true then
        self.curPanel:updateHeroPanelInfo(self.data);
    end
    
    if self.isSignOpenW then
        self.isSignOpenW = false;
    end
end

--更新页签状态
function Lua_HeroShowAttributeWindow:updateTabState()
    local len = self.showArr:getSize();
    if len == 1 then
        self.sub_btn:setEnable(false);
        self.add_btn:setEnable(false);
    else
        if self.showIdx == 1 then
            self.sub_btn:setEnable(false);
            self.add_btn:setEnable(true);
        elseif self.showIdx == len then
            self.sub_btn:setEnable(true);
            self.add_btn:setEnable(false);
        else
            self.sub_btn:setEnable(true);
            self.add_btn:setEnable(true);
        end
    end
end

-- 上锁
function Lua_HeroShowAttributeWindow:onLockBtnClick()
    if self.data.lock_state == false then
        Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroLock(self.data.unique_id, 1);
    else
        Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroLock(self.data.unique_id, 0);
    end
end

--传记
function Lua_HeroShowAttributeWindow:onIntroduceBtnClick()
    Lua_WindowUtil.openWin("Lua_HeroBiographyWindow", Lua_WinParam.ACTION_OPEN,self.data);
end

--评论
function Lua_HeroShowAttributeWindow:onCommentBtnClick()
    Lua_WindowUtil.openWin("Lua_HeroCommentWindow", Lua_WinParam.ACTION_OPEN, self.data);
end

--重修
function Lua_HeroShowAttributeWindow:onRebuildBtnClick()
    if self.data.is_resonance == true then
        self:showttips();
        return;
    elseif self.data.trial_state then
        OperateAlert.show("试用英雄不可重生");
        return;
    end
    Lua_WindowUtil.openWin("Lua_HeroRebuildWindow", Lua_WinParam.ACTION_OPEN, self.data);
end

function Lua_HeroShowAttributeWindow:showttips()
    local tipData = {
        h = 443, font_size = 26, des = LanUtil.getValue(126919), posY = 44,
        btnType = 1, owner = self, sureFun = self.sendDemount
    };
    Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

--从同调器中卸下
function Lua_HeroShowAttributeWindow:sendDemount()
    local grid_id = DataCenter.lifeTreeData:getGridIdByUid(self.data.unique_id);
    if grid_id == 0 then
        return;
    end
    Lua_ProxyManager.getProxy("Lua_LifeTreeProxy"):sDemountHero(grid_id);
end

function Lua_HeroShowAttributeWindow:dispose()
    if self.tabInfo ~= nil then
        self.tabInfo:dispose();
        self.tabInfo:clear();
        self.tabInfo = nil;
    end

    if self.curPanel ~= nil then
        self.curPanel:dispose();
        self.curPanel = nil;
    end

    if self.redDotEff ~= nil then
        self.redDotEff:dispose();
        self.redDotEff = nil;
    end

    self.data = nil;
    self.showArr = nil;
    self.panelName = nil;
    if Lua_WindowUtil.isWindowShowing("Lua_HeroAttrAnimationWindow") then
        Lua_WindowUtil.openWin("Lua_HeroAttrAnimationWindow", Lua_WinParam.ACTION_CLOSE);
    end
    self:superCall("dispose");
    Lua_MsgUtil.callFunc("ENFORCE_UPDATA_HERO_PANEL");
end















-- 检测引导数据
function Lua_HeroShowAttributeWindow:checkWinGuide()
    self:superCall("checkWinGuide");
end

-- 引导同步
function Lua_HeroShowAttributeWindow:updateGuide(guideId, info)
    if info == nil or self.data == nil then
        return;
    end
    local operateVal = info.operateVal; -- 操作行为参数
    if operateVal == nil then
        return;
    end

    local heroLevel = info.heroLevel ~= nil and tonumber(info.heroLevel) or 1;
    if operateVal == 1 then -- 升级到特定等级
        Lua_MsgUtil.callFunc("Guide_UpHeroGrade_Panel", heroLevel);
        Lua_CommonUtil.delayCall(0.1, self, self.delayUpdateGuideData, guideId);
    elseif operateVal == 2 then -- 指定页签
        local tabNum = info.tabNum or 1;
        local item = self.tabList.showDragDataList:getItem(tabNum);--.cell;
        if item ~= nil then
            item = item.cell;
            if self.selectTabId ~= nil and self.selectTabId == tabNum then
                DataCenter.guideCommonData.winGuideResult = 1;
            else
                item:checkCellPressInGuide(true, guideId);
            end
            DataCenter.guideCommonData.guideClickObjTarget = item.content;
            DataCenter.guideCommonData.guideSceneId = nil; -- 场景
            Lua_MsgUtil.callFunc("Guide_WinSync_Complete", guideId);
        end
    end
end

function Lua_HeroShowAttributeWindow:delayUpdateGuideData(guideId)
    DataCenter.guideCommonData.guideSceneId = nil; -- 场景
    -- DataCenter.guideCommonData.guideClickObjPath = "content/Lua_HeroAttributePanel/upgrade_btn";
    DataCenter.guideCommonData.guideClickObjPath = "content/downObj/Lua_HeroAttributePanel/showObj2/upgrade_btn";
    Lua_MsgUtil.callFunc("Guide_WinSync_Complete", guideId);
end