-- 英雄展示 基类
Lua_HeroShowBaseWindow = class("Lua_HeroShowBaseWindow", Lua_Window);
function Lua_HeroShowBaseWindow:ctor()
    self:superCall("ctor");
    
    self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
    self.windowName = "Lua_HeroShowBaseWindow";
    self.skinName = "HeroShowBaseWindow_skin";
    self.isFullSizeWin = true;
    self.isSingleShowWin = true;
    self.showBackBtn = true;
end

function Lua_HeroShowBaseWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.comment_btn:setEnable(false);--评论屏蔽
    self.introduce_btn:setEnable(false);
    self.star_bg:setEnable(false);
    self.star_level:setEnable(false);
    self.forceNum = Lua_NumberImage.new(self.attr_obj);
    self.forceNum.pivot = 1;
    self.forceNum.scaleVal = 0.8
    self.forceNum.preStr = "ui_zl2_number_0";
    self.forceNum:setLocation(-15, -210, 0);
    self.forceNum.numOffsetX = -10;
    self.forceNum.num = 0;
end

function Lua_HeroShowBaseWindow:showStarsItem(data) -- 显示星
    if data ~= nil and data.star <10 then
        if self.starInfo == nil then
            self.starInfo = Array();
        end
        local showStar = data.showStar;
        local len = self.starInfo:getSize();
        local spr = DataCenter.heroUtil:getStarSprite(data.star, 2);
        local starWidth = 35;
        local num = len;
        if len < showStar then
            num = showStar;
        end
        for i = 1, num do
            local item = self.starInfo[i];
            if item == nil then
                item = UICreate.createUIAtlasImage(self.upObj, "common_altas_1", "ui_common_label_06", 0, 0, 36, 35);
                self.starInfo:add(item);
            else
                item:setEnable(i <= showStar);
            end  
            item:setLocation(-1 * starWidth * showStar / 2 + starWidth * (i-1) + starWidth / 2, 621, 0);
            item:setAltas("common_altas_1", spr);
        end
        self.star_bg:setEnable(false);
        self.star_level:setEnable(false);
    else
        if self.starInfo ~= nil then
            local len = self.starInfo:getSize();
            for i = 1, len do
                self.starInfo[i]:setEnable(false);
            end
        end
        if data == nil then
            self.star_bg:setEnable(false);
            self.star_level:setEnable(false);
        elseif data.star >= 10 then
            self.star_bg:setEnable(true);
            self.star_level:setEnable(data.showStar > 0);
            self.star_level.text = data.showStar;
        end
    end
end

function Lua_HeroShowBaseWindow:showHeroMondel(data)
    local tag_id = data.unique_id;
    if tag_id == nil then
        tag_id = data.id;
    end
    -- print(self.showTagId,"   showHeroMondel  =",tag_id)
    if self.showTagId == tag_id then
        return
    end
    self.showTagId = tag_id;
    
    if self.modelScenePanel == nil then
        self.modelScenePanel = Lua_ModelScenePanel.new();
        self.modelScenePanel:setParent(self.content);
        self.modelScenePanel:setRotBgPos(0, 189);
        self.modelScenePanel:setRotBgDimensions(720,815+self.adaptHeight);
    end

    -- 预加载已初始化第一次
    if self._bEnterFirst or not self.modelScenePanel.bShowModel then
        self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UISHOW, data.showActEffs);
        self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UIWAIT, data.poseActEffs);
        self.modelScenePanel:showModelScene(data.uiSceneId, data.uiModelUrl, data.uiModelAvatarName, data.uiModelCamController);
        self.modelScenePanel:setModelAct(data.uiShowAct, Lua_ThingDefine.UIWAIT, true);
    end

    -- 修改朝向
    self._bEnterFirst = true;
    self.modelScenePanel:setModelDir(data.uiModelDir);
    self.modelScenePanel:setModelScale(data.uiModelScale);
end

function Lua_HeroShowBaseWindow:showWin(param)
    self:superCall("showWin", param);
    if param ~= nil and param.modelScenePanel ~= nil then -- 模型展示界面
        self.modelScenePanel = param.modelScenePanel;
        self.modelScenePanel:setParent(self.content);
        self.modelScenePanel:setRotBgPos(0, 189);
        self.modelScenePanel:setRotBgDimensions(720,815+self.adaptHeight);
        param.modelScenePanel = nil;
    end
end

function Lua_HeroShowBaseWindow:dispose()
    if self.forceNum ~= nil then
        self.forceNum:dispose();
        self.forceNum = nil;
    end

    if self.starInfo ~= nil then
        self.starInfo:dispose();
        self.starInfo:clear();
        self.starInfo = nil;
    end

    if self.modelScenePanel ~= nil then
        self.modelScenePanel:dispose();
        self.modelScenePanel = nil;
    else
        local l = Lua_WindowUtil.getWinListData(self.windowName, true);
        if l ~= nil then
            for i = 1, l:getSize() do
                local param = l[i];
                if param.modelScenePanel ~= nil then
                    param.modelScenePanel:dispose();
                    param.modelScenePanel = nil;
                end
            end
        end
    end

    self:superCall("dispose");
end

function Lua_HeroShowBaseWindow:resetActive(bActive)
    self:superCall("resetActive", bActive);
    if bActive then -- 显示
        if self.data ~= nil then
            self:showHeroMondel(self.data);
        end
    else
        if self.modelScenePanel ~= nil then
            self.modelScenePanel:dispose();
            self.modelScenePanel = nil;
        end
    end
end