--英雄tips
checkRequire("Lua_HeroRunesItem");
checkRequire("Lua_HeroEquipItem");
checkRequire("Lua_HeroTalentItem");
checkRequire("Lua_HeroSkillItem"); --英雄技能 Item
checkRequire("Lua_HeroAttributeItem");--英雄属性 
Lua_HeroTipsWindow = class("Lua_HeroTipsWindow", Lua_Window);
function Lua_HeroTipsWindow:ctor()
    self:superCall("ctor");
    self.windowName = "Lua_HeroTipsWindow";
    self.skinName = "HeroTipsWindow_skin";
    self.showBlackMask = true;
    self.isClickClose = true;
end

function Lua_HeroTipsWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.heroItemIcon = Lua_HeroItemIcon.new(self.content);
    self.heroItemIcon:setLocation(-222,405,0);
    self.sprite.siblingIndex = 20;

    self.forceNum = Lua_NumberImage.new(self.content);
	self.forceNum:setLocation(-96, 435, 0);
	self.forceNum.pivot = 1;
	self.forceNum.scaleVal = 0.8;
	self.forceNum.numAtlas = "number";
	self.forceNum.preStr = "ui_zl1_number_0";

	self.attr_btn:addClickFuntion(self, self.attrBtnClick);--详情属性
	self.comment_btn:setEnable(false);
	self.comment_btn:addClickFuntion(self, self.commentBtnClick);--评论
end

function Lua_HeroTipsWindow:showWin(param)
	self:superCall("showWin",param);--param = 英雄vo
	if self.isWindowShowing == true then
		return;
	end
	self.isWindowShowing = true;
	self:showTipsInfo(param);
end

-- 展示
function Lua_HeroTipsWindow:showTipsInfo(hvo)
	self.name.text = hvo.name;
	self.forceNum.num = hvo.heroForce;
	self.profession.text = hvo.career_des;

    local attrInfo = hvo.heroPropVo.heroPropInfo;--属性
	local skillInfo = hvo.heroSkillInfo;--技能
	local talentInfo = hvo.talentInfo;--战技

	local runeInfo;--符石
	local equipInfo;--装备
	local vo = DataCenter.heroData:getItemByUniqueId(hvo.unique_id);
	if vo ~= nil then--自己英雄信息
		equipInfo = vo.equipInfo;
		runeInfo = vo.runsInfo;
	else--别人英雄信息
		equipInfo = hvo.equipTipsInfo;
		runeInfo = hvo.runsTipsInfo;
	end
	self.heroItemIcon:setData(hvo);
	self.heroItemIcon:showFightIcon(false);

	self:showAttr(attrInfo);
	self:showFightSkill(skillInfo);
	self:showEquip(equipInfo, hvo);
	self:showRunes(runeInfo, hvo);
	self:showTalentInfo(talentInfo, hvo);
end

-- 属性展示
function Lua_HeroTipsWindow:showAttr(info)
    local len = info:getSize();
    if len == 0 then
    	return;
    end
	self.attributeArr = Array();
    local item;
    for i = 1, len do
        item = Lua_HeroAttributeItem.new(self.attr_obj, 1);
        item:setData(info[i]);
        if Mathf.Floor((i+1)/2) == 1 then
        	item:setLocation(-102+(i-1)*233, 377, 0);
        else
        	item:setLocation(-102+(i-3)*233, 324, 0);
        end
        item:setEnable(true);
        self.attributeArr:add(item);
    end
end

-- 技能
function Lua_HeroTipsWindow:showFightSkill(list)
	local len = #list;
    if len == 0 then
    	return;
    end
    self.skillArr = Array();
	local item;
    local skilWidth = 156;
    for i=1,len do
        item = Lua_HeroSkillItem.new(self.skill_obj);
        item:setData(list[i]);
        item:setLocation(-1 * skilWidth * len / 2 + skilWidth * (i-1) + skilWidth / 2+8, -94, 0);
        item:setEnable(true);
        self.skillArr:add(item);
    end
end

--装备
function Lua_HeroTipsWindow:showEquip(list, hvo)
	self.showEquipArr = Array();
	local item;
	for i=1,4 do
		item = Lua_HeroEquipItem.new(self.equip_obj, 1);
		item.part = i;
		item:setData(list[i], hvo);
		item:setLocation(-226+(i-1)*157, -100, 0);
		self.showEquipArr:add(item);
	end
end

--符石
function Lua_HeroTipsWindow:showRunes(list, hvo)
    self.showSunesArr = Array();
	local item;
	for i=1,2 do
		item = Lua_HeroRunesItem.new(self.runes_obj, 1);
		item.part = i;
		item:setData(list[i], hvo);
		item:setLocation(-136+(i-1)*294, -97, 0);
		self.showSunesArr:add(item);
	end
end

--战技
function Lua_HeroTipsWindow:showTalentInfo(list, hvo)
	self.showTalentArr = Array();
	local item;
	for i=1,2 do
		item = Lua_HeroTalentItem.new(self.talent_obj, 1);
		item.part = i;
		if list and #list >= i then
			item:setData(list[i], hvo);
		else
			item:setData(nil, hvo);
		end
		item:setLocation(-140+(i-1)*298, -93, 0);
		self.showTalentArr:add(item);
	end
end

function Lua_HeroTipsWindow:attrBtnClick()
	Lua_WindowUtil.openWin("Lua_HeroAllAttributeWindow", Lua_WinParam.ACTION_OPEN,{data = self.showData});
end


function Lua_HeroTipsWindow:commentBtnClick()
	Lua_WindowUtil.openWin("Lua_HeroCommentWindow", Lua_WinParam.ACTION_OPEN, self.showData);
end

function Lua_HeroTipsWindow:dispose()
	if self.forceNum ~= nil then
		self.forceNum:dispose();
		self.forceNum = nil;
	end
	if self.heroItemIcon ~= nil then
		self.heroItemIcon:dispose();
		self.heroItemIcon = nil;
	end
	if self.skillArr ~= nil then
        self.skillArr:dispose();
        self.skillArr:clear();
        self.skillArr = nil;
    end
    if self.attributeArr ~= nil then
        self.attributeArr:dispose();
        self.attributeArr:clear();
        self.attributeArr = nil;
    end
    if self.showEquipArr ~= nil then
		self.showEquipArr:dispose();
		self.showEquipArr:clear();
		self.showEquipArr = nil;
	end
	if self.showSunesArr ~= nil then
		self.showSunesArr:dispose();
		self.showSunesArr:clear();
		self.showSunesArr = nil;
	end
	if self.showTalentArr ~= nil then
		self.showTalentArr:dispose();
		self.showTalentArr:clear();
		self.showTalentArr = nil;
	end
    self:superCall("dispose");
end
