--英雄系统主界面
checkRequire("Lua_HeroPanel");--英雄
checkRequire("Lua_HeroAtlasPanel");--英雄图鉴
checkRequire("Lua_HeroFetterPanel");--英雄羁绊
Lua_HeroWindow = class("Lua_HeroWindow", Lua_Window);
function Lua_HeroWindow:ctor()
	self:superCall("ctor");
	self.layer = MainWinDefine.MAIN_WINDOW_LAYER;
	self.isFullSizeWin = true;
	self.showWinBg = true;
	self.winBgPath = "/images/common/ui_common_bg_001.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
	self.showClose = false;
	self.showBackBtn = false;--显示返回按键
    self.showTitle = true;--显示标题栏
	self.titleSprite = "fonts_1_002";
	self.windowName = "Lua_HeroWindow";
	self.skinName = "HeroWindow_skin";
	self.openSound = "bgm_zhucheng";
	self.closeSound = "";
end

function Lua_HeroWindow:resetActive(bActive)
	self:superCall("resetActive", bActive);
	if bActive then
		AudioManager.instance:play(self.openSound);
	end
end

function Lua_HeroWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.panelObjTab = {};
	
	self.tabInfo = Array();
    self.tabInfo:add({textStr = LanUtil.getValue(126000), tagType = Lua_HeroUtil.HERO_TYPE, panel = Lua_HeroPanel});
    self.tabInfo:add({textStr = LanUtil.getValue(126001), tagType = Lua_HeroUtil.ATLAS_TYPE, panel = Lua_HeroAtlasPanel});
    -- self.tabInfo:add({textStr = LanUtil.getValue(126352), tagType = Lua_HeroUtil.FETTER_TYPE, panel = Lua_HeroFetterPanel});
    self.line2:setEnable(false);
    self.line1:setLocation(0,-540,0);
    self.btnList = Lua_ButtonList.new(self.downobj, Lua_AxisDefine.Horizontal);
    self.btnList:setLocation(0, -541, 0);
    self.btnList:setButtonItem(360, 67);
    self.btnList:setButtonStyle("common_altas_1","ui_common_tab_01","ui_common_tab_01",360,67,0.01);
    self.btnList:setClickCallBack(self, self.onTabBtnClick);
    self.btnList:setData(self.tabInfo);

    self.embattleIcon:addClickFuntion(self, self.onOpenLineupClick);
    self:addLuaEvent("GUIDE_SELECT_HERO_TARGETITEM", self, self.guideSelectHeroPath);-- 选择英雄item的路径
end

function Lua_HeroWindow:showWin(param)
	self:superCall("showWin", param);

	local idx = 1;
	if type(param) == "number" then
		idx = param;
	else
		idx = param.main_id;
	end
	self.btnList:setSelected(idx);
end

function Lua_HeroWindow:onTabBtnClick(val)
	if self.selectTabIndex == val then
		return;
	end
	self.line:setEnable(self.tabInfo[val].tagType ~= Lua_HeroUtil.FETTER_TYPE);
	-- 隐藏旧的
	self.panel = self.panelObjTab[self.selectTabIndex];
	if self.panel ~= nil then
		self.panel:setEnable(false);
	end
	self.selectTabIndex = val;
	self.panel = self.panelObjTab[val];
	if self.panelObjTab[val] == nil then
		local showPanel = self.tabInfo[val].panel;
		self.panel = showPanel.new(self.content);
		self.panelObjTab[val] = self.panel;
	else
		self.panel:setEnable(true);
		if self.panel.updateShow ~= nil then
			self.panel:updateShow();
		end
	end
	self:onScreenResize();
end

function Lua_HeroWindow:onScreenResize()
	self:superCall("onScreenResize");
	if self.panel ~= nil then
		self.panel:setRectSize(self.width, self.height);
	end
end

function Lua_HeroWindow:onOpenLineupClick() -- 打开布阵
	local sceneId = DataCenter.heroLineupData:getLineUpSceneId(Lua_HeroUtil.LINEUP_MAIN_TYPE);
	DataCenter.preLoadData:preShowScene("Lua_HeroLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, Lua_HeroUtil.LINEUP_MAIN_TYPE, sceneId, 0);
end

function Lua_HeroWindow:onSceneShow(param)
	Lua_WindowUtil.openWin("Lua_HeroLineupWindow", Lua_WinParam.ACTION_OPEN, param);
end

function Lua_HeroWindow:dispose()
	if self.tabBtnList ~= nil then
		self.tabBtnList:dispose();
		self.tabBtnList = nil;
	end

	if self.redDot ~= nil then
		self.redDot:dispose();
		self.redDot = nil;
	end

	if self.panelObjTab ~= nil then
		for idx, panelObj in pairs(self.panelObjTab) do
            panelObj:dispose();
            self.panelObjTab[idx] = nil;
        end
		self.panelObjTab = nil;
	end
	self.panel = nil;

	if self.tabInfo ~= nil then
		self.tabInfo:dispose();
		self.tabInfo:clear();
		self.tabInfo = nil;
	end

	DataCenter.preLoadData:removeBySign("Lua_HeroLineupWindow", self, self.onSceneShow);
	-- Lua_CommonUtil.removeTimer(self, self.showEmbattleRedDot);
	self:superCall("dispose");
end







-- 检测引导数据
function Lua_HeroWindow:checkWinGuide()
    self:superCall("checkWinGuide");
end

-- 引导同步
function Lua_HeroWindow:updateGuide(guideId, info)
    if info == nil then
        return;
    end

    local operateVal = info.operateVal; -- 操作行为参数
    if operateVal == nil then
        return;
    end

    if operateVal == 1 then -- 查找英雄item
    	self.guideId = guideId;
    	local heroId = info.heroId;
    	Lua_MsgUtil.callFunc("GUIDE_SELECTED_HERO", heroId);
    end
end

function Lua_HeroWindow:guideSelectHeroPath(targetPath)
	if targetPath ~= nil then
		DataCenter.guideCommonData.guideSceneId = nil; -- 场景
		DataCenter.guideCommonData.guideClickObjPath = targetPath;
		Lua_MsgUtil.callFunc("Guide_WinSync_Complete", self.guideId);
	end
end